--Chapter 1
--No code

--Chapter 2
SELECT  dopc.cntr_value,
        dopc.cntr_type
FROM    sys.dm_os_performance_counters AS dopc
WHERE   dopc.object_name =  'SQLServer:General Statistics' 
        AND dopc.counter_name =  'Logins/sec';


SELECT TOP(10)
    dows.*
FROM sys.dm_os_wait_stats AS dows
ORDER BY dows.wait_time_ms DESC;


EXEC sp_configure 'show advanced options', 1;
GO
RECONFIGURE;
GO
EXEC sp_configure  'min server memory'; 
EXEC sp_configure  'max server memory';


USE master;
EXEC sp_configure  'show advanced option',   1;
RECONFIGURE;
exec sp_configure  'min server memory (MB)',  5120;
exec sp_configure  'max server memory (MB)',  10240;
RECONFIGURE WITH OVERRIDE;


--Chapter 3
SELECT  *
FROM    sys.dm_io_virtual_file_stats(DB_ID('AdventureWorks2017'), 2) AS divfs;


SELECT  *
FROM    sys.dm_os_wait_stats AS dows
WHERE   wait_type LIKE 'PAGEIOLATCH%';


ALTER DATABASE WideWorldImporters
ADD FILEGROUP Indexes;
ALTER DATABASE WideWorldImporters
ADD FILE
    (
        NAME = AdventureWorks2017_Data2,
        FILENAME = 'c:\DATA\WWI_Index.ndf',
        SIZE = 20GB,
        FILEGROWTH = 10%
    )
TO FILEGROUP Indexes;



SELECT si.StockItemName,
       s.SupplierName
FROM Warehouse.StockItems AS si
JOIN Purchasing.Suppliers AS s
    ON si.SupplierID = s.SupplierID;



USE master;
GO
EXEC sp_detach_db 'WideWorldImporters';
GO


USE master;
GO
sp_attach_db 'WideWorldImporters',
 'R:\DATA\WWI_Primary.mdf',
R:\DATA\WWI_UserData.ndf,
 'F:\DATA\WWI_Indexes.ndf',
R:\DATA\WWI_InMemory.ndf,
 'S:\LOG\WWI_Log.1df ';
GO


USE WideWorldImporters;
GO
SELECT * FROM sys.database_files;
GO


--Chapter 4
--No code



--Chapter 5
--No code




--Chapter 6
ALTER EVENT SESSION QueryMetrics
ON SERVER 
STATE = START;



CREATE EVENT SESSION [QueryMetrics]
ON SERVER
    ADD EVENT sqlserver.sql_batch_completed
    (SET collect_batch_text = (1)
     WHERE ([sqlserver].[database_name] = N'AdventureWorks2017')
    )
    ADD TARGET package0.event_file
    (SET filename = N'c:\PerfData\QueryMetrics')
WITH
(
    MAX_MEMORY = 4096KB,
    EVENT_RETENTION_MODE = ALLOW_SINGLE_EVENT_LOSS,
    MAX_DISPATCH_LATENCY = 30 SECONDS,
    MAX_EVENT_SIZE = 0KB,
    MEMORY_PARTITION_MODE = NONE,
    TRACK_CAUSALITY = OFF,
    STARTUP_STATE = OFF
);
GO



SELECT  dxs.name,
        dxs.create_time
FROM    sys.dm_xe_sessions AS dxs;


CREATE EVENT SESSION ProcedureMetrics
ON SERVER
    ADD EVENT sqlserver.rpc_completed
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.rpc_starting
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.sp_statement_completed
    (SET collect_object_name = (1))
    ADD TARGET package0.event_file
    (SET filename = N'C:\PerfData\ProcedureMetrics.xel')
WITH
(
    TRACK_CAUSALITY = ON
);
GO


SELECT path
FROM sys.dm_os_server_diagnostics_log_configurations;
GO




SELECT * FROM sys.dm_exec_query_stats AS deqs




--Chapter 7
SELECT module_guid,
       package_guid,
       object_name,
       event_data,
       file_name,
       file_offset,
       timestamp_utc
FROM sys.fn_xe_file_target_read_file('C:\Sessions\QueryPerformanceMetrics*.xel',
                                     NULL,
                                     NULL,
                                     NULL);




WITH    xEvents
          AS (SELECT    object_name AS xEventName,
                        CAST (event_data AS XML) AS xEventData
              FROM      sys.fn_xe_file_target_read_file('C:\PerfData\QueryMetrics*.xel',
                                                        NULL, NULL, NULL)
             )
    SELECT  xEventName,
            xEventData.value('(/event/data[@name=''duration'']/value)[1]',
                             'bigint') Duration,
            xEventData.value('(/event/data[@name=''physical_reads'']/value)[1]',
                             'bigint') PhysicalReads,
            xEventData.value('(/event/data[@name=''logical_reads'']/value)[1]',
                             'bigint') LogicalReads,
            xEventData.value('(/event/data[@name=''cpu_time'']/value)[1]',
                             'bigint') CpuTime,
            CASE xEventName
              WHEN 'sql_batch_completed'
              THEN xEventData.value('(/event/data[@name=''batch_text'']/value)[1]',
                                    'varchar(max)')
              WHEN 'rpc_completed'
              THEN xEventData.value('(/event/data[@name=''statement'']/value)[1]',
                                    'varchar(max)')
            END AS SQLText
    INTO    Session_Table
    FROM    xEvents;


SELECT  st.xEventName,
        st.Duration,
        st.PhysicalReads,
        st.LogicalReads,
        st.CpuTime,
        st.SQLText
FROM    Session_Table AS st
ORDER BY st.LogicalReads DESC;


SELECT s.TotalExecutionCount,
       t.text,
       s.TotalExecutionCount,
       s.TotalElapsedTime,
       s.TotalLogicalReads,
       s.TotalPhysicalReads
FROM
(
    SELECT deqs.plan_handle,
           SUM(deqs.execution_count) AS TotalExecutionCount,
           SUM(deqs.total_elapsed_time) AS TotalElapsedTime,
           SUM(deqs.total_logical_reads) AS TotalLogicalReads,
           SUM(deqs.total_physical_reads) AS TotalPhysicalReads
    FROM sys.dm_exec_query_stats AS deqs
    GROUP BY deqs.plan_handle
) AS s
    CROSS APPLY sys.dm_exec_sql_text(s.plan_handle) AS t
ORDER BY s.TotalLogicalReads DESC;


SELECT s.TotalExecutionCount,
       t.text,
       s.TotalExecutionCount,
       s.TotalElapsedTime,
       s.TotalLogicalReads,
       s.TotalPhysicalReads
FROM
(
    SELECT deqs.query_plan_hash,
           SUM(deqs.execution_count) AS TotalExecutionCount,
           SUM(deqs.total_elapsed_time) AS TotalElapsedTime,
           SUM(deqs.total_logical_reads) AS TotalLogicalReads,
           SUM(deqs.total_physical_reads) AS TotalPhysicalReads
    FROM sys.dm_exec_query_stats AS deqs
    GROUP BY deqs.query_plan_hash
) AS s
    CROSS APPLY
(
    SELECT plan_handle
    FROM sys.dm_exec_query_stats AS deqs
    WHERE s.query_plan_hash = deqs.query_plan_hash
) AS p
    CROSS APPLY sys.dm_exec_sql_text(p.plan_handle) AS t
ORDER BY TotalLogicalReads DESC;




WITH xEvents
AS (SELECT object_name AS xEventName,
           CAST(event_data AS XML) AS xEventData
    FROM sys.fn_xe_file_target_read_file('Q:\Sessions\QueryPerformanceMetrics*.xel', NULL, NULL, NULL)
   )
SELECT xEventName,
       xEventData.value('(/event/data[@name=''duration'']/value)[1]', 'bigint') Duration,
       xEventData.value('(/event/data[@name=''physical_reads'']/value)[1]', 'bigint') PhysicalReads,
       xEventData.value('(/event/data[@name=''logical_reads'']/value)[1]', 'bigint') LogicalReads,
       xEventData.value('(/event/data[@name=''cpu_time'']/value)[1]', 'bigint') CpuTime,
       xEventData.value('(/event/data[@name=''batch_text'']/value)[1]', 'varchar(max)') BatchText,
       xEventData.value('(/event/data[@name=''statement'']/value)[1]', 'varchar(max)') StatementText,
       xEventData.value('(/event/data[@name=''query_plan_hash'']/value)[1]', 'binary(8)') QueryPlanHash
FROM xEvents
ORDER BY Duration DESC;


DROP TABLE dbo.Session_Table


USE AdventureWorks2017;
GO
SET SHOWPLAN_XML ON;
GO
SELECT soh.AccountNumber,
       sod.LineTotal,
       sod.OrderQty,
       sod.UnitPrice,
       p.Name
FROM Sales.SalesOrderHeader soh
    JOIN Sales.SalesOrderDetail sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product p
        ON sod.ProductID = p.ProductID
WHERE sod.LineTotal > 20000;

GO
SET SHOWPLAN_XML OFF;
GO


SELECT soh.AccountNumber,
       sod.LineTotal,
       sod.OrderQty,
       sod.UnitPrice,
       p.Name
FROM Sales.SalesOrderHeader soh
    JOIN Sales.SalesOrderDetail sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product p
        ON sod.ProductID = p.ProductID
WHERE sod.LineTotal > 20000;



SELECT p.Name AS ProductName,
       pc.Name AS ProductCategoryName
FROM Production.Product p
    JOIN Production.ProductCategory pc
        ON p.ProductSubcategoryID = pc.ProductCategoryID;


SELECT pm.Name AS ProductModelName,
       pmpd.CultureID
FROM Production.ProductModel pm
    JOIN Production.ProductModelProductDescriptionCulture pmpd
        ON pm.ProductModelID = pmpd.ProductModelID;


SELECT pm.Name AS ProductName,
       pmpd.CultureID
FROM Production.ProductModel pm
    JOIN Production.ProductModelProductDescriptionCulture pmpd
        ON pm.ProductModelID = pmpd.ProductModelID
WHERE pm.Name = 'HL Mountain Front Wheel';


DROP TABLE IF EXISTS dbo.TransactionHistory;

SELECT *
INTO dbo.TransactionHistory
FROM Production.TransactionHistory AS th;

GO


CREATE CLUSTERED COLUMNSTORE INDEX ClusteredColumnStoreTest
ON dbo.TransactionHistory;

GO

SELECT p.Name,
       th.Quantity
FROM dbo.TransactionHistory AS th
    JOIN Production.Product AS p
        ON p.ProductID = th.ProductID
WHERE th.Quantity > 550;

GO

CREATE OR ALTER PROC p1
AS
CREATE TABLE t1 (c1 INT);

INSERT INTO t1
SELECT ProductID
FROM Production.Product;

SELECT *
FROM t1;

DROP TABLE t1;
GO

SET SHOWPLAN_XML ON;
GO
EXEC p1 ;
GO
SET SHOWPLAN_XML OFF;
GO

SET STATISTICS XML ON;
GO
EXEC p1;
GO
SET STATISTICS XML OFF;
GO




SELECT p.query_plan,
       t.text
FROM sys.dm_exec_cached_plans r
    CROSS APPLY sys.dm_exec_query_plan(r.plan_handle) p
    CROSS APPLY sys.dm_exec_sql_text(r.plan_handle) t;



SELECT soh.AccountNumber,
       sod.LineTotal,
       sod.OrderQty,
       sod.UnitPrice,
       p.Name
FROM Sales.SalesOrderHeader soh
    JOIN Sales.SalesOrderDetail sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product p
        ON sod.ProductID = p.ProductID
WHERE sod.LineTotal > 20000;




SELECT p.Name,
       th.Quantity
FROM dbo.TransactionHistory AS th
    JOIN Production.Product AS p
        ON p.ProductID = th.ProductID
WHERE th.Quantity > 550;

SELECT p.Name,
       th.Quantity
FROM dbo.TransactionHistory AS th
    JOIN Production.Product AS p
        ON p.ProductID = th.ProductID
WHERE th.Quantity > 35000;



SELECT deqp.physical_operator_name,
       deqp.node_id,
       deqp.thread_id,
       deqp.row_count,
       deqp.rewind_count,
       deqp.rebind_count
FROM sys.dm_exec_query_profiles AS deqp;


--run in different window
SELECT *
FROM sys.columns AS c,
     sys.syscolumns AS s;



DBCC TRACEON(7412);


CREATE EVENT SESSION QueryThreadProfile
ON SERVER
    ADD EVENT sqlserver.query_thread_profile
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.sql_batch_completed
    (WHERE (sqlserver.database_name = N'AdventureWorks2017'))
WITH (TRACK_CAUSALITY = ON)
GO






SELECT TOP 100
    p.Name,
    p.ProductNumber
FROM Production.Product p;


SET STATISTICS TIME ON;
GO
SELECT soh.AccountNumber,
       sod.LineTotal,
       sod.OrderQty,
       sod.UnitPrice,
       p.Name
FROM Sales.SalesOrderHeader soh
    JOIN Sales.SalesOrderDetail sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product p
        ON sod.ProductID = p.ProductID
WHERE sod.LineTotal > 1000;
GO
SET STATISTICS TIME OFF;
GO



SET STATISTICS IO ON;
GO
SELECT soh.AccountNumber,
       sod.LineTotal,
       sod.OrderQty,
       sod.UnitPrice,
       p.Name
FROM Sales.SalesOrderHeader soh
    JOIN Sales.SalesOrderDetail sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product p
        ON sod.ProductID = p.ProductID
WHERE sod.SalesOrderID = 71856;
GO
SET STATISTICS IO OFF;
GO





--Chapter 8
SELECT TOP 10
    p.ProductID,
    p.[Name],
    p.StandardCost,
    p.[Weight],
    ROW_NUMBER() OVER (ORDER BY p.Name DESC) AS RowNumber
FROM Production.Product p
ORDER BY p.Name DESC;




DROP TABLE IF EXISTS dbo.Test1;
CREATE TABLE dbo.Test1
(
    C1 INT,
    C2 INT,
    C3 VARCHAR(50)
);

WITH Nums
AS (SELECT TOP (10000)
        ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS n
    FROM master.sys.all_columns ac1
        CROSS JOIN master.sys.all_columns ac2
   )
INSERT INTO dbo.Test1
(
    C1,
    C2,
    C3
)
SELECT n,
       n,
       'C3'
FROM Nums;


UPDATE dbo.Test1
SET C1 = 1,
    C2 = 1
WHERE C2 = 1;

CREATE CLUSTERED INDEX iTest 
ON dbo.Test1(C1);

CREATE NONCLUSTERED INDEX iTest2 
ON dbo.Test1(C2);

UPDATE dbo.Test1
SET C1 = 1,
    C2 = 1
WHERE C2 = 1;





SELECT p.ProductID,
       p.Name,
       p.StandardCost,
       p.Weight
FROM Production.Product p;


SELECT p.ProductID,
       p.Name,
       p.StandardCost,
       p.Weight
FROM Production.Product AS p
WHERE p.ProductID = 738;



DROP TABLE IF EXISTS dbo.Test1; 
GO
CREATE TABLE dbo.Test1 (C1 INT, C2 INT); 

WITH    Nums
          AS (SELECT    1 AS n
              UNION ALL
              SELECT    n + 1
              FROM      Nums
              WHERE     n < 20
             )
    INSERT  INTO dbo.Test1
            (C1, C2)
            SELECT  n,
                    2
            FROM    Nums;

CREATE INDEX iTest ON dbo.Test1(C1);

SELECT i.name,
       i.type_desc,
       ddips.page_count,
       ddips.record_count,
       ddips.index_level
FROM sys.indexes i
    JOIN sys.dm_db_index_physical_stats(   DB_ID(N'AdventureWorks2017'),
                                           OBJECT_ID(N'dbo.Test1'),
                                           NULL,
                                           NULL,
                                           'DETAILED'
                                       ) AS ddips
        ON i.index_id = ddips.index_id
WHERE i.object_id = OBJECT_ID(N'dbo.Test1');

DROP INDEX dbo.Test1.iTest;
ALTER TABLE dbo.Test1 ALTER COLUMN C1 CHAR(500);
CREATE INDEX iTest ON dbo.Test1(C1);

DROP TABLE dbo.Test1;


SELECT COUNT(DISTINCT e.MaritalStatus) AS DistinctColValues,
       COUNT(e.MaritalStatus) AS NumberOfRows,
       (CAST(COUNT(DISTINCT e.MaritalStatus) AS DECIMAL) 
		/ CAST(COUNT(e.MaritalStatus) AS DECIMAL)) AS Selectivity,
       (1.0 / (COUNT(DISTINCT e.MaritalStatus))) AS Density
FROM HumanResources.Employee AS e;








DBCC DROPCLEANBUFFERS()

SELECT e.MaritalStatus,
       e.BirthDate
FROM HumanResources.Employee AS e
WHERE e.MaritalStatus = 'M'
      AND e.BirthDate = '1982-02-11';

CREATE INDEX IX_Employee_Test ON HumanResources.Employee (MaritalStatus);

CREATE INDEX IX_Employee_Test
ON HumanResources.Employee
(
    BirthDate,
    MaritalStatus
)
WITH (DROP_EXISTING = ON);

DROP INDEX IX_Employee_Test ON HumanResources.Employee


CREATE INDEX IX_Employee_Test
ON HumanResources.Employee
(
    MaritalStatus
)
WITH (DROP_EXISTING = ON);


SELECT e.MaritalStatus,
       e.BirthDate
FROM HumanResources.Employee AS e WITH (INDEX(IX_Employee_Test))
WHERE e.MaritalStatus = 'M'
      AND e.BirthDate = '1982-02-11';

SELECT e.MaritalStatus,
       e.BirthDate
FROM HumanResources.Employee AS e WITH (FORCESEEK)
WHERE e.MaritalStatus = 'M'
      AND e.BirthDate = '1982-02-11';




SELECT p.ProductID FROM Production.Product AS p
WHERE p.ProductSubcategoryID = 1;

SELECT p.ProductID FROM Production.Product AS p
WHERE p.ProductSubcategoryID = 1
AND p.ProductModelID = 19;



CREATE INDEX IX_Test ON Person.Address (City, PostalCode);


SELECT a.City,
       a.PostalCode
FROM Person.Address AS a
WHERE a.City = 'Dresden';


SELECT a.City,
       a.PostalCode
FROM Person.Address AS a
WHERE a.PostalCode = '01071';

DROP INDEX Person.Address.IX_Test;



SELECT dl.DatabaseLogID,
       dl.PostTime
FROM dbo.DatabaseLog AS dl
WHERE dl.DatabaseLogID = 115;



SELECT d.DepartmentID,
       d.ModifiedDate
FROM HumanResources.Department AS d
WHERE d.DepartmentID = 10;


DROP TABLE IF EXISTS dbo.Test1;
GO
CREATE TABLE dbo.Test1 (
    C1 INT,
    C2 INT);

WITH Nums
AS (SELECT TOP (20)
        ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS n
    FROM master.sys.all_columns ac1
        CROSS JOIN master.sys.all_columns ac2)
INSERT INTO dbo.Test1 (
    C1,
    C2)
SELECT n,
       n + 1
FROM Nums;

CREATE CLUSTERED INDEX iClustered ON dbo.Test1 (C2);

CREATE NONCLUSTERED INDEX iNonClustered ON dbo.Test1 (C1);



SELECT i.name,
       i.type_desc,
       s.page_count,
       s.record_count,
       s.index_level
FROM sys.indexes i
    JOIN sys.dm_db_index_physical_stats(DB_ID(N'AdventureWorks2017'),
                                        OBJECT_ID(N'dbo.Test1'),
                                        NULL,
                                        NULL,
                                        'DETAILED') AS s
        ON i.index_id = s.index_id
WHERE i.object_id = OBJECT_ID(N'dbo.Test1');


DROP INDEX dbo.Test1.iClustered;
ALTER TABLE dbo.Test1 ALTER COLUMN C2 CHAR(500);
CREATE CLUSTERED INDEX iClustered ON dbo.Test1(C2);


DROP TABLE dbo.Test1
DROP TABLE dbo.t1


IF (
       SELECT OBJECT_ID('od')) IS NOT NULL
    DROP TABLE dbo.od;
GO
SELECT pod.*
INTO dbo.od
FROM Purchasing.PurchaseOrderDetail AS pod;


EXEC sp_helpindex 'dbo.od';


SELECT od.*
FROM dbo.od
WHERE od.ProductID
BETWEEN 500 AND 510
ORDER BY od.ProductID;



CREATE CLUSTERED INDEX i1 ON od(ProductID);


DROP INDEX od.i1;
CREATE NONCLUSTERED INDEX i1 on dbo.od(ProductID);

DROP TABLE dbo.od;



BEGIN TRAN;
SET STATISTICS IO ON;
UPDATE Sales.SpecialOfferProduct
SET ProductID = 345
WHERE SpecialOfferID = 1
      AND ProductID = 720;
SET STATISTICS IO OFF;
ROLLBACK TRAN;

CREATE NONCLUSTERED INDEX ixTest 
ON Sales.SpecialOfferProduct (ModifiedDate);



DROP INDEX Sales.SpecialOfferProduct.ixTest;




DROP TABLE IF EXISTS dbo.Test1;
CREATE TABLE dbo.Test1 (
    C1 INT,
    C2 INT);

WITH Nums
AS (SELECT TOP (10000)
        ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS n
    FROM master.sys.all_columns AS ac1
        CROSS JOIN master.sys.all_columns AS ac2)
INSERT INTO dbo.Test1 (
    C1,
    C2)
SELECT n,
       2
FROM Nums;



SELECT t.C1,
       t.C2
FROM dbo.Test1 AS t
WHERE C1 = 1000;


CREATE NONCLUSTERED INDEX incl ON dbo.Test1(C1);

CREATE CLUSTERED INDEX icl ON dbo.Test1(C1);



SELECT cc.CreditCardID,
       cc.CardNumber,
       cc.ExpMonth,
       cc.ExpYear
FROM Sales.CreditCard cc
WHERE cc.ExpMonth
      BETWEEN 6 AND 9
      AND cc.ExpYear = 2008
ORDER BY cc.ExpMonth;



CREATE NONCLUSTERED INDEX ixTest
ON Sales.CreditCard
(
    ExpYear,
    ExpMonth)
INCLUDE
(
    CardNumber)
WITH DROP_EXISTING;

DROP INDEX ixTest ON Sales.CreditCard 






--Chapter 9
SELECT a.PostalCode
FROM Person.Address AS a
WHERE a.StateProvinceID = 42;

CREATE NONCLUSTERED INDEX IX_Address_StateProvinceID
ON Person.Address
(
    StateProvinceID ASC
)
INCLUDE
(
    PostalCode
)
WITH (DROP_EXISTING = ON);

CREATE NONCLUSTERED INDEX IX_Address_StateProvinceID
ON Person.Address
(
    StateProvinceID ASC
)
WITH (DROP_EXISTING = ON);




--SELECT * is intentionally used in this query
SELECT soh.*
FROM Sales.SalesOrderHeader AS soh
WHERE soh.SalesPersonID = 276
      AND soh.OrderDate
      BETWEEN '4/1/2013' AND '7/1/2013';


CREATE NONCLUSTERED INDEX IX_Test ON Sales.SalesOrderHeader (OrderDate);


DROP INDEX IX_Test ON Sales.SalesOrderHeader




SELECT soh.SalesPersonID,
       soh.OrderDate
FROM Sales.SalesOrderHeader AS soh
WHERE soh.SalesPersonID = 276
      AND soh.OrderDate
      BETWEEN '4/1/2013' AND '7/1/2013';


CREATE NONCLUSTERED INDEX IX_Test 
ON Sales.SalesOrderHeader (OrderDate ASC);

DROP INDEX IX_Test ON Sales.SalesOrderHeader



SELECT soh.SalesPersonID,
       soh.OrderDate
FROM Sales.SalesOrderHeader AS soh 
		WITH (INDEX(IX_Test, IX_SalesOrderHeader_SalesPersonID))
WHERE soh.OrderDate
BETWEEN '4/1/2013' AND '7/1/2013';





SELECT soh.PurchaseOrderNumber,
       soh.OrderDate,
       soh.ShipDate,
       soh.SalesPersonID
FROM Sales.SalesOrderHeader AS soh
WHERE PurchaseOrderNumber LIKE 'PO5%'
      AND soh.SalesPersonID IS NOT NULL;

CREATE NONCLUSTERED INDEX IX_Test
ON Sales.SalesOrderHeader
(
    PurchaseOrderNumber,
    SalesPersonID
)
INCLUDE
(
    OrderDate,
    ShipDate
)
WITH (DROP_EXISTING = ON);


CREATE NONCLUSTERED INDEX IX_Test
ON Sales.SalesOrderHeader
(
    PurchaseOrderNumber,
    SalesPersonID
)
INCLUDE
(
    OrderDate,
    ShipDate
)
WHERE PurchaseOrderNumber IS NOT NULL
      AND SalesPersonID IS NOT NULL
WITH (DROP_EXISTING = ON);



DROP INDEX Sales.SalesOrderHeader.IX_Test;


SELECT  p.[Name] AS ProductName,
        SUM(pod.OrderQty) AS OrderOty,
        SUM(pod.ReceivedQty) AS ReceivedOty,
        SUM(pod.RejectedQty) AS RejectedOty
FROM    Purchasing.PurchaseOrderDetail AS pod
        JOIN Production.Product AS p
        ON p.ProductID = pod.ProductID
GROUP BY p.[Name];

SELECT  p.[Name] AS ProductName,
        SUM(pod.OrderQty) AS OrderOty,
        SUM(pod.ReceivedQty) AS ReceivedOty,
        SUM(pod.RejectedQty) AS RejectedOty
FROM    Purchasing.PurchaseOrderDetail AS pod
        JOIN Production.Product AS p
        ON p.ProductID = pod.ProductID
GROUP BY p.[Name]
HAVING  (SUM(pod.RejectedQty) / SUM(pod.ReceivedQty)) > .08;

SELECT  p.[Name] AS ProductName,
        SUM(pod.OrderQty) AS OrderQty,
        SUM(pod.ReceivedQty) AS ReceivedQty,
        SUM(pod.RejectedQty) AS RejectedQty
FROM    Purchasing.PurchaseOrderDetail AS pod
        JOIN Production.Product AS p
        ON p.ProductID = pod.ProductID
WHERE   p.[Name] LIKE 'Chain%'
GROUP BY p.[Name];



IF EXISTS ( SELECT  *
            FROM    sys.views
            WHERE   object_id = OBJECT_ID(N'[Purchasing].[IndexedView]') )
    DROP VIEW [Purchasing].[IndexedView];
GO
CREATE OR ALTER VIEW Purchasing.IndexedView
WITH SCHEMABINDING
AS
SELECT pod.ProductID,
       SUM(pod.OrderQty) AS OrderQty,
       SUM(pod.ReceivedQty) AS ReceivedQty,
       SUM(pod.RejectedQty) AS RejectedQty,
       COUNT_BIG(*) AS Count
FROM Purchasing.PurchaseOrderDetail AS pod
GROUP BY pod.ProductID;
GO
CREATE UNIQUE CLUSTERED INDEX iv 
ON Purchasing.IndexedView (ProductID);
GO



SELECT  iv.ProductID,
        iv.ReceivedQty,
        iv.RejectedQty
FROM    Purchasing.IndexedView AS iv;


--compression

CREATE NONCLUSTERED INDEX IX_Test
ON Person.Address
(
    City ASC,
    PostalCode ASC
);


CREATE NONCLUSTERED INDEX IX_Comp_Test
ON Person.Address
(
    City,
    PostalCode
)
WITH (DATA_COMPRESSION = ROW);

CREATE NONCLUSTERED INDEX IX_Comp_Page_Test
ON Person.Address
(
    City,
    PostalCode
)
WITH (DATA_COMPRESSION = PAGE);

SELECT i.name,
       i.type_desc,
       s.page_count,
       s.record_count,
       s.index_level,
       s.compressed_page_count
FROM sys.indexes AS i
    JOIN sys.dm_db_index_physical_stats(DB_ID(N'AdventureWorks2017'),
                                        OBJECT_ID(N'Person.Address'),
                                        NULL,
                                        NULL,
                                        'DETAILED') AS s
        ON i.index_id = s.index_id
WHERE i.object_id = OBJECT_ID(N'Person.Address');


--ix_test
SELECT  a.City,
        a.PostalCode
FROM    Person.Address AS a WITH (INDEX = IX_Test)
WHERE   a.City = 'Newton'
        AND a.PostalCode = 'V2M1N7';
--ix_comp_test
SELECT  a.City,
        a.PostalCode
FROM    Person.Address AS a WITH (INDEX = IX_Comp_Test)
WHERE   a.City = 'Newton'
        AND a.PostalCode = 'V2M1N7';
--ix_comp_page_test
SELECT  a.City,
        a.PostalCode
FROM    Person.Address AS a WITH (INDEX = IX_Comp_Page_Test)
WHERE   a.City = 'Newton'
        AND a.PostalCode = 'V2M1N7';


DROP INDEX Person.Address.IX_Test; 
DROP INDEX Person.Address.IX_Comp_Test; 
DROP INDEX Person.Address.IX_Comp_Page_Test;


--columnstore
SELECT  tha.ProductID,
        COUNT(tha.ProductID) AS CountProductID,
        SUM(tha.Quantity) AS SumQuantity,
        AVG(tha.ActualCost) AS AvgActualCost
FROM    Production.TransactionHistoryArchive AS tha
GROUP BY tha.ProductID;

DBCC FREEPROCCACHE()


SELECT bp.Name AS ProductName,
       COUNT(bth.ProductID),
       SUM(bth.Quantity),
       AVG(bth.ActualCost)
FROM dbo.bigProduct AS bp
    JOIN dbo.bigTransactionHistory AS bth
        ON bth.ProductID = bp.ProductID
GROUP BY bp.Name;


CREATE NONCLUSTERED COLUMNSTORE INDEX ix_csTest
ON dbo.bigTransactionHistory
(
    ProductID,
    Quantity,
    ActualCost
);



SELECT ddcsrgps.row_group_id,
       ddcsrgps.state_desc,
       ddcsrgps.total_rows,
       ddcsrgps.trim_reason_desc,
       ddcsrgps.transition_to_compressed_state_desc
FROM sys.dm_db_column_store_row_group_physical_stats AS ddcsrgps
WHERE ddcsrgps.object_id = OBJECT_ID('dbo.bigTransactionHistory')
ORDER BY ddcsrgps.row_group_id ASC;






CREATE NONCLUSTERED INDEX IX_Test 
ON Person.Address (City);

DROP INDEX IX_Test ON Person.Address;







--Chapter 10

SELECT soh.DueDate,
       soh.CustomerID,
       soh.Status
FROM Sales.SalesOrderHeader AS soh
WHERE soh.DueDate
BETWEEN '1/1/2008' AND '2/1/2008';


GO
CREATE OR ALTER PROCEDURE dbo.uspProductSize
AS
SELECT p.ProductID,
       p.Size
FROM Production.Product AS p
WHERE p.Size = '62';

EXEC dbo.uspProductSize




--Chapter 11
ALTER DATABASE AdventureWorks2017 SET QUERY_STORE = ON;
GO


CREATE OR ALTER PROC dbo.ProductTransactionHistoryByReference (
     @ReferenceOrderID int
    )
AS
BEGIN
    SELECT  p.Name,
            p.ProductNumber,
            th.ReferenceOrderID
    FROM    Production.Product AS p
    JOIN    Production.TransactionHistory AS th
            ON th.ProductID = p.ProductID
    WHERE   th.ReferenceOrderID = @ReferenceOrderID;
END
GO

--generate three plans
DECLARE @Planhandle VARBINARY(64);

EXEC dbo.ProductTransactionHistoryByReference @ReferenceOrderID = 0;

SELECT @Planhandle = deps.plan_handle
FROM sys.dm_exec_procedure_stats AS deps
WHERE deps.object_id = OBJECT_ID('dbo.ProductTransactionHistoryByReference');

IF @Planhandle IS NOT NULL
BEGIN
    DBCC FREEPROCCACHE(@Planhandle);
END

EXEC dbo.ProductTransactionHistoryByReference @ReferenceOrderID = 53465;

SELECT @Planhandle = deps.plan_handle
FROM sys.dm_exec_procedure_stats AS deps
WHERE deps.object_id = OBJECT_ID('dbo.ProductTransactionHistoryByReference');

IF @Planhandle IS NOT NULL
BEGIN
    DBCC FREEPROCCACHE(@Planhandle);
END

EXEC dbo.ProductTransactionHistoryByReference @ReferenceOrderID = 3849;










SELECT qsq.query_id,
       qsq.object_id,
       qsqt.query_sql_text,
       CAST(qsp.query_plan AS XML)
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_query_text AS qsqt
        ON qsq.query_text_id = qsqt.query_text_id
    JOIN sys.query_store_plan AS qsp
        ON qsp.query_id = qsq.query_id
WHERE qsq.object_id = OBJECT_ID('dbo.ProductTransactionHistoryByReference');
GO



CREATE OR ALTER PROC dbo.ProductTransactionHistoryByReference (
     @ReferenceOrderID int
    )
AS
BEGIN
    SELECT  p.Name,
            p.ProductNumber,
            th.ReferenceOrderID
    FROM    Production.Product AS p
    JOIN    Production.TransactionHistory AS th
            ON th.ProductID = p.ProductID
    WHERE   th.ReferenceOrderID = @ReferenceOrderID;
END

SELECT a.AddressID,
       a.AddressLine1
FROM Person.Address AS a
WHERE a.AddressID = 72;


SELECT qsq.query_id,
       qsq.query_hash,
       qsqt.query_sql_text
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_query_text AS qsqt
        ON qsqt.query_text_id = qsq.query_text_id
WHERE qsqt.query_sql_text = 'SELECT a.AddressID,
       a.AddressLine1
FROM Person.Address AS a
WHERE a.AddressID = 72;';



SELECT qsq.query_id,
       qsq.query_hash,
       qsqt.query_sql_text,
       qsq.query_parameterization_type
FROM sys.query_store_query_text AS qsqt
    JOIN sys.query_store_query AS qsq
        ON qsq.query_text_id = qsqt.query_text_id
    JOIN sys.fn_stmt_sql_handle_from_sql_stmt(
             'SELECT a.AddressID,
       a.AddressLine1
FROM Person.Address AS a
WHERE a.AddressID = 72;',
             2)  AS fsshfss
        ON fsshfss.statement_sql_handle = qsqt.statement_sql_handle;



DECLARE @CompareTime DATETIME = '2018-5-14 11:13';

SELECT CAST(qsp.query_plan AS XML),
       qsrs.count_executions,
       qsrs.avg_duration,
       qsrs.stdev_duration,
       qsws.wait_category_desc,
       qsws.avg_query_wait_time_ms,
       qsws.stdev_query_wait_time_ms
FROM sys.query_store_plan AS qsp
    JOIN sys.query_store_runtime_stats AS qsrs
        ON qsrs.plan_id = qsp.plan_id
    JOIN sys.query_store_wait_stats AS qsws
        ON qsws.plan_id = qsrs.plan_id
           AND qsws.runtime_stats_interval_id = qsrs.runtime_stats_interval_id
		   AND qsws.execution_type = qsrs.execution_type
	JOIN sys.query_store_runtime_stats_interval AS qsrsi
		ON qsrs.runtime_stats_interval_id = qsrsi.runtime_stats_interval_id
WHERE qsq.object_id = OBJECT_ID('dbo.ProductTransactionHistoryByReference')
      AND @CompareTime BETWEEN qsrsi.start_time
                       AND     qsrsi.end_time;


go



ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;
GO


SELECT *
FROM sys.columns AS c,
     sys.syscolumns AS s;


SELECT qsqt.query_sql_text,
       qsrs.execution_type,
       qsrs.avg_duration
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_query_text AS qsqt
        ON qsqt.query_text_id = qsq.query_text_id
    JOIN sys.query_store_plan AS qsp
        ON qsp.query_id = qsq.query_id
    JOIN sys.query_store_runtime_stats AS qsrs
        ON qsrs.plan_id = qsp.plan_id
WHERE qsqt.query_sql_text like '%FROM sys.columns AS c%';




WITH QSAggregate
AS (SELECT qsrs.plan_id,
           SUM(qsrs.count_executions) AS CountExecutions,
           AVG(qsrs.avg_duration) AS AvgDuration,
           AVG(qsrs.stdev_duration) AS StdDevDuration,
           qsws.wait_category_desc,
           AVG(qsws.avg_query_wait_time_ms) AS AvgWaitTime,
           AVG(qsws.stdev_query_wait_time_ms) AS StDevWaitTime
    FROM sys.query_store_runtime_stats AS qsrs
        JOIN sys.query_store_wait_stats AS qsws
            ON qsws.plan_id = qsrs.plan_id
               AND qsws.runtime_stats_interval_id = qsrs.runtime_stats_interval_id
    GROUP BY qsrs.plan_id,
             qsws.wait_category_desc)
SELECT CAST(qsp.query_plan AS XML),
       qsa.*
FROM sys.query_store_plan AS qsp
    JOIN QSAggregate AS qsa
        ON qsa.plan_id = qsp.plan_id
WHERE qsq.object_id = OBJECT_ID('dbo.ProductTransactionHistoryByReference');



ALTER DATABASE AdventureWorks2017 SET QUERY_STORE = OFF;

ALTER DATABASE AdventureWorks2017 SET QUERY_STORE CLEAR;

EXEC sys.sp_query_store_remove_query
    @query_id = @queryid;

EXEC sys.sp_query_store_remove_query 4


	EXEC sys.sp_query_store_reset_exec_stats
    @plan_id = 81	;


EXEC sys.sp_query_store_flush_db;

SELECT * FROM sys.database_query_store_options AS dqso;






EXEC sys.sp_query_store_force_plan 75,82;

EXEC sys.sp_query_store_unforce_plan 75,82;


--Chapter 12

SELECT p.Name,
       AVG(sod.LineTotal)
FROM Sales.SalesOrderDetail AS sod
    JOIN Production.Product AS p
        ON sod.ProductID = p.ProductID
WHERE sod.ProductID = 776
GROUP BY sod.CarrierTrackingNumber,
         p.Name
HAVING MAX(sod.OrderQty) > 1
ORDER BY MIN(sod.LineTotal);
GO 20


SELECT *
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 776;


SELECT  *
FROM    Sales.SalesOrderDetail AS sod
WHERE   sod.ProductID = 793;


SELECT *
FROM Sales.SalesOrderDetail AS sod WITH (INDEX(IX_SalesOrderDetail_ProductID))
WHERE sod.ProductID = 793;


SELECT NationalIDNumber,
       JobTitle,
       HireDate
FROM HumanResources.Employee AS e
WHERE e.NationalIDNumber = '693168613';


CREATE UNIQUE NONCLUSTERED INDEX AK_Employee_NationalIDNumber
ON HumanResources.Employee
(
    NationalIDNumber ASC,
    JobTitle ASC,
    HireDate ASC
)
WITH DROP_EXISTING;


SELECT i.name AS IndexName,
       SUM(s.used_page_count) * 8 AS IndexSizeKB
FROM sys.dm_db_partition_stats AS s
    INNER JOIN sys.indexes AS i
        ON s.object_id = i.object_id
           AND s.index_id = i.index_id
WHERE i.name = 'AK_Employee_NationalIDNumber'
GROUP BY i.name
ORDER BY i.name;



CREATE UNIQUE NONCLUSTERED INDEX AK_Employee_NationalIDNumber
ON HumanResources.Employee
(
    NationalIDNumber ASC
)
INCLUDE
(
    JobTitle,
    HireDate
)
WITH DROP_EXISTING;



SELECT NationalIDNumber,
       BusinessEntityID
FROM HumanResources.Employee AS e
WHERE e.NationalIDNumber BETWEEN '693168613'
                         AND     '7000000000';


CREATE UNIQUE NONCLUSTERED INDEX AK_Employee_NationalIDNumber
ON HumanResources.Employee
(
    NationalIDNumber ASC
)
WITH DROP_EXISTING;


DBCC SHOW_STATISTICS('HumanResources.Employee', AK_Employee_NationalIDNumber);


CREATE UNIQUE NONCLUSTERED INDEX [AK_Employee_NationalIDNumber] ON
[HumanResources].[Employee]
(NationalIDNumber ASC,  
JobTitle ASC,  
HireDate ASC )
WITH DROP_EXISTING ;

DBCC FREEPROCCACHE()


SELECT poh.PurchaseOrderID,
       poh.VendorID,
       poh.OrderDate
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE VendorID = 1636
      AND poh.OrderDate = '2014/6/24';

CREATE NONCLUSTERED INDEX IX_TEST
ON Purchasing.PurchaseOrderHeader
(
    OrderDate
);

SELECT * FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.VendorID = 1636

GO

--Chapter 13

SELECT *
FROM sys.dm_db_stats_histogram(OBJECT_ID('HumanResources.Employee'),
                               1) AS ddsh;



SELECT *
FROM sys.dm_db_stats_properties(OBJECT_ID('HumanResources.Employee'),
                                2)


DROP TABLE IF EXISTS dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT IDENTITY);

SELECT TOP 1500
    IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS sC1,
     master.dbo.syscolumns AS sC2;

INSERT INTO dbo.Test1 (C1)
SELECT n
FROM #Nums;

DROP TABLE #Nums;

CREATE NONCLUSTERED INDEX i1 ON dbo.Test1 (C1);



SELECT *
FROM dbo.Test1
WHERE C1 = 2;


CREATE EVENT SESSION [Statistics]
ON SERVER
    ADD EVENT sqlserver.auto_stats
    (ACTION (sqlserver.sql_text)
     WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.sql_batch_completed
    (WHERE (sqlserver.database_name = N'AdventureWorks2017'));
GO
ALTER EVENT SESSION [Statistics] ON SERVER STATE = START;
GO

DROP EVENT SESSION [Statistics] ON SERVER;


INSERT  INTO dbo.Test1
        (C1)
VALUES  (2);


SELECT TOP 1500
    IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sC2;
INSERT INTO dbo.Test1 (C1)
SELECT 2
FROM #Nums;
DROP TABLE #Nums;



IF (SELECT OBJECT_ID('Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT IDENTITY);

SELECT TOP 1500
    IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS sC1,
     master.dbo.syscolumns AS sC2;

INSERT INTO dbo.Test1 (C1)
SELECT n
FROM #Nums;

DROP TABLE #Nums;

CREATE NONCLUSTERED INDEX i1 ON dbo.Test1 (C1);

ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS OFF;

SELECT TOP 1500
    IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sC2;
INSERT INTO dbo.Test1 (C1)
SELECT 2
FROM #Nums;
DROP TABLE #Nums;

SELECT *
FROM dbo.Test1
WHERE C1 = 2;

ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS ON;





IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO

CREATE TABLE dbo.Test1 (Test1_C1 INT IDENTITY,
                        Test1_C2 INT);

INSERT INTO dbo.Test1 (Test1_C2)
VALUES (1);

SELECT TOP 10000
       IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sC2;

INSERT INTO dbo.Test1 (Test1_C2)
SELECT 2
FROM #Nums
GO

CREATE CLUSTERED INDEX i1 ON dbo.Test1 (Test1_C1)

--Create second table with 10001 rows, -- but opposite data distribution 
IF (SELECT OBJECT_ID('dbo.Test2')) IS NOT NULL
    DROP TABLE dbo.Test2;
GO

CREATE TABLE dbo.Test2 (Test2_C1 INT IDENTITY,
                        Test2_C2 INT);

INSERT INTO dbo.Test2 (Test2_C2)
VALUES (2);

INSERT INTO dbo.Test2 (Test2_C2)
SELECT 1
FROM #Nums;
DROP TABLE #Nums;
GO

CREATE CLUSTERED INDEX il ON dbo.Test2 (Test2_C1);




SELECT DATABASEPROPERTYEX('AdventureWorks2017',
                          'IsAutoCreateStatistics');



SELECT t1.Test1_C2,
       t2.Test2_C2
FROM dbo.Test1 AS t1
    JOIN dbo.Test2 AS t2
        ON t1.Test1_C2 = t2.Test2_C2
WHERE t1.Test1_C2 = 2;


SELECT s.name,
       s.auto_created,
       s.user_created
FROM sys.stats AS s
WHERE object_id = OBJECT_ID('Test1');



SELECT t1.Test1_C2,
       t2.Test2_C2
FROM dbo.Test1 AS t1
    JOIN dbo.Test2 AS t2
        ON t1.Test1_C2 = t2.Test2_C2
WHERE t1.Test1_C2 = 1;


SELECT *
FROM sys.stats_columns
WHERE object_id = OBJECT_ID('Test1');


SELECT c.name,
       sc.object_id,
       sc.stats_column_id,
       sc.stats_id
FROM sys.stats_columns AS sc
    JOIN sys.columns AS c
        ON c.object_id = sc.object_id
           AND c.column_id = sc.column_id
WHERE sc.object_id = OBJECT_ID('Test1');


DROP STATISTICS Test1._WA_Sys_00000002_20ACD28B;
DROP STATISTICS dbo.Test2._WA_Sys_00000002_21A0F6C4;

ALTER DATABASE AdventureWorks2017 SET AUTO_CREATE_STATISTICS OFF;

SELECT  Test1.Test1_C2,
        Test2.Test2_C2
FROM    dbo.Test1
        JOIN dbo.Test2
        ON Test1.Test1_C2 = Test2.Test2_C2
WHERE   Test1.Test1_C2 = 2;


SELECT  Test1.Test1_C2,
        Test2.Test2_C2
FROM    dbo.Test2
JOIN    dbo.Test1
        ON Test1.Test1_C2 = Test2.Test2_C2
WHERE   Test1.Test1_C2 = 2;


DBCC FREEPROCCACHE



SELECT dest.text AS query,
       deqs.execution_count,
       deqp.query_plan
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_text_query_plan(deqs.plan_handle,
                                            deqs.statement_start_offset,
                                            deqs.statement_end_offset) AS detqp
    CROSS APPLY sys.dm_exec_query_plan(deqs.plan_handle) AS deqp
    CROSS APPLY sys.dm_exec_sql_text(deqs.sql_handle) AS dest
WHERE detqp.query_plan LIKE '%ColumnsWithNoStatistics%';

ALTER DATABASE AdventureWorks2017 SET AUTO_CREATE_STATISTICS ON;



IF (SELECT  OBJECT_ID('dbo.Test1')
   ) IS NOT NULL 
    DROP TABLE dbo.Test1 ; 
GO

CREATE TABLE dbo.Test1 (C1 INT, C2 INT IDENTITY) ;

INSERT  INTO dbo.Test1
        (C1)
VALUES  (1) ;

SELECT TOP 10000
        IDENTITY( INT,1,1 ) AS n
INTO    #Nums 
FROM    Master.dbo.SysColumns sc1,
        Master.dbo.SysColumns sc2 ;
        
INSERT  INTO dbo.Test1
        (C1)
        SELECT  2
        FROM    #Nums ;
        
DROP TABLE #Nums;
      
CREATE NONCLUSTERED INDEX FirstIndex ON dbo.Test1 (C1) ;



DBCC SHOW_STATISTICS(Test1, FirstIndex);


--Retrieve 1 row; 
SELECT  *
FROM    dbo.Test1
WHERE   C1 = 1;

--Retrieve 10000 rows; 
SELECT  *
FROM    dbo.Test1
WHERE   C1 = 2;

SELECT 1.0 / COUNT(DISTINCT C1)
FROM dbo.Test1;



SELECT  p.Name,
        p.Class
FROM    Production.Product AS p
WHERE   p.Color = 'Red' AND
        p.DaysToManufacture > 15;


SELECT s.name,
       s.auto_created,
       s.user_created,
       s.filter_definition,
       sc.column_id,
       c.name AS ColumnName
FROM sys.stats AS s
    JOIN sys.stats_columns AS sc
        ON sc.stats_id = s.stats_id
           AND sc.object_id = s.object_id
    JOIN sys.columns AS c
        ON c.column_id = sc.column_id
           AND c.object_id = s.object_id
WHERE s.object_id = OBJECT_ID('Production.Product');


CREATE NONCLUSTERED INDEX FirstIndex
ON dbo.Test1
(
    C1,
    C2
)
WITH (DROP_EXISTING = ON);

DBCC SHOW_STATISTICS('dbo.Test1','FirstIndex')


SELECT 1.0 / COUNT(*)
FROM
(SELECT DISTINCT C1, C2 FROM dbo.Test1) AS DistinctRows;


CREATE INDEX IX_Test ON Sales.SalesOrderHeader (PurchaseOrderNumber);


DBCC SHOW_STATISTICS('Sales.SalesOrderHeader',IX_Test);

CREATE INDEX IX_Test
ON Sales.SalesOrderHeader
(
    PurchaseOrderNumber
)
WHERE PurchaseOrderNumber IS NOT NULL
WITH (DROP_EXISTING = ON);


DROP INDEX Sales.SalesOrderHeader.IX_Test;

--cardinality

--legacy
ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = ON;



SELECT a.AddressID,
       a.AddressLine1,
       a.AddressLine2
FROM Person.Address AS a
WHERE a.AddressLine1 = '5980 Icicle Circle'
      AND AddressLine2 = 'Unit H';


ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = OFF;
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;



--full function
SELECT  so.Description,
        p.Name AS ProductName,
        p.ListPrice,
        p.Size,
        pv.AverageLeadTime,
        pv.MaxOrderQty,
        v.Name AS VendorName
FROM    Sales.SpecialOffer AS so
JOIN    Sales.SpecialOfferProduct AS sop
ON      sop.SpecialOfferID = so.SpecialOfferID
JOIN    Production.Product AS p
ON      p.ProductID = sop.ProductID
JOIN    Purchasing.ProductVendor AS pv
ON      pv.ProductID = p.ProductID
JOIN    Purchasing.Vendor AS v
ON      v.BusinessEntityID = pv.BusinessEntityID
WHERE so.DiscountPct > .15;



SELECT p.Name,
       p.Class
FROM Production.Product AS p
WHERE p.Color = 'Red'
      AND p.DaysToManufacture > 15
OPTION (QUERYTRACEON 9481);


ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = ON;


SELECT cc.CardNumber,
       cc.ExpMonth,
       cc.ExpYear
FROM Sales.CreditCard AS cc
WHERE cc.CardType = 'Vista';


IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;

CREATE TABLE dbo.Test1 (C1 INT);

CREATE INDEX ixl ON dbo.Test1 (C1);

INSERT INTO dbo.Test1 (C1)
VALUES (0);


SELECT C1
FROM dbo.Test1
WHERE C1 = 0;

ALTER DATABASE AdventureWorks2017 SET AUTO_CREATE_STATISTICS OFF;

ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS OFF;

ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS_ASYNC ON;

USE AdventureWorks2017;
EXEC sp_autostats 'HumanResources.Department', 'OFF';

EXEC sp_autostats 'HumanResources.Department', 'OFF', AK_Department_Name;

EXEC sp_autostats 'HumanResources.Department';

EXEC sp_autostats 'HumanResources.Department', 'ON';
EXEC sp_autostats 'HumanResources.Department', 'ON', AK_Department_Name;


CREATE STATISTICS MultiColumnExample
ON dbo.bigProduct (ProductNumber,
                   Name);

UPDATE STATISTICS dbo.bigProduct WITH RESAMPLE, INCREMENTAL=ON;

SELECT is_auto_create_stats_on
FROM sys.databases
WHERE name = 'AdventureWorks2017';

USE AdventureWorks2017;
EXEC sys.sp_autostats 'HumanResources.Department';

SELECT  DATABASEPROPERTYEX('AdventureWorks2017', 'IsAutoUpdateStatistics');


ALTER DATABASE AdventureWorks2017 SET AUTO_CREATE_STATISTICS OFF;
ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS OFF;

DROP TABLE IF EXISTS dbo.Test1;
GO

CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT,
                        C3 CHAR(50));
INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3)
VALUES (51, 1, 'C3'),
       (52, 1, 'C3');

CREATE NONCLUSTERED INDEX iFirstIndex ON dbo.Test1 (C1, C2);

SELECT TOP 10000
       IDENTITY(INT, 1, 1) AS n
INTO #Nums
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sC2;

INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3)
SELECT n % 50,
       n,
       'C3'
FROM #Nums;
DROP TABLE #Nums;

GO

SELECT  *
FROM    dbo.Test1
WHERE   C2 = 1;


CREATE STATISTICS Stats1 ON Test1(C2);


DECLARE @Planhandle VARBINARY(64);

SELECT @Planhandle = deqs.plan_handle
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.sql_handle) AS dest
WHERE dest.text LIKE '%SELECT *
FROM dbo.Test1
WHERE C1 = 51;%'

IF @Planhandle IS NOT NULL
BEGIN
    DBCC FREEPROCCACHE(@Planhandle);
END
GO

DBCC SHOW_STATISTICS (Test1, iFirstIndex);


SELECT *
FROM dbo.Test1
WHERE C1 = 51;

UPDATE STATISTICS Test1 iFirstIndex WITH FULLSCAN;


ALTER DATABASE AdventureWorks2017 SET AUTO_CREATE_STATISTICS ON; 
ALTER DATABASE AdventureWorks2017 SET AUTO_UPDATE_STATISTICS ON;


SELECT SQRT(1000.0*500000)
GO
;





WITH histo
AS (SELECT ddsh.step_number,
           ddsh.range_high_key,
           ddsh.range_rows,
           ddsh.equal_rows,
           ddsh.average_range_rows
    FROM sys.dm_db_stats_histogram(OBJECT_ID('HumanResources.Employee'),
                                   1) AS ddsh ),
     histojoin
AS (SELECT h1.step_number,
           h1.range_high_key,
           h2.range_high_key AS range_high_key_step1,
           h1.range_rows,
           h1.equal_rows,
           h1.average_range_rows
    FROM histo AS h1
        LEFT JOIN histo AS h2
            ON h1.step_number = h2.step_number + 1)
SELECT hj.range_high_key,
       hj.equal_rows,
       hj.average_range_rows
FROM histojoin AS hj
WHERE hj.range_high_key >= 17
      AND (   hj.range_high_key_step1 < 17
              OR hj.range_high_key_step1 IS NULL);






SELECT ddsp.object_id,
       ddsp.stats_id,
       ddsp.last_updated
FROM sys.dm_db_stats_properties(OBJECT_ID('HumanResources.Employee'),
                                2) AS ddsp;



--Chapter 14
USE AdventureWorks2017;
GO
IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 CHAR(999),
                        C3 VARCHAR(10))
INSERT INTO dbo.Test1
VALUES (100, 'C2', ''),
       (200, 'C2', ''),
       (300, 'C2', ''),
       (400, 'C2', ''),
       (500, 'C2', ''),
       (600, 'C2', ''),
       (700, 'C2', ''),
       (800, 'C2', '');

CREATE CLUSTERED INDEX iClust ON dbo.Test1 (C1);




SELECT ddips.avg_fragmentation_in_percent,
       ddips.fragment_count,
       ddips.page_count,
       ddips.avg_page_space_used_in_percent,
       ddips.record_count,
       ddips.avg_record_size_in_bytes
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'dbo.Test1'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS ddips;



UPDATE dbo.Test1
SET C3 = 'Add data'
WHERE C1 = 200;


DBCC IND(AdventureWorks2017, 'dbo.Test1', -1);


INSERT INTO dbo.Test1
VALUES (410, 'C4', ''),
       (900, 'C4', '');


DBCC TRACEON(3604);
DBCC PAGE('AdventureWorks2017',1,258819,3);

INSERT INTO Test1
VALUES (110, 'C2', '');

INSERT  INTO dbo.Test1
VALUES  (410, 'C4', ''),
        (900, 'C4', '');


--columnstore fragmentation
--setup
ALTER TABLE dbo.bigTransactionHistory
DROP CONSTRAINT pk_bigTransactionHistory;

CREATE CLUSTERED COLUMNSTORE INDEX cci_bigTransactionHistory
ON dbo.bigTransactionHistory;


--checking for fragmentation
SELECT OBJECT_NAME(i.object_id) AS TableName,
       i.name AS IndexName,
       csrg.partition_number,
       csrg.row_group_id,
       csrg.state_description,
       csrg.total_rows,
       csrg.deleted_rows,
       100 * (total_rows - ISNULL(deleted_rows,
                                  0)) / total_rows AS PercentFull
FROM sys.indexes AS i
    JOIN sys.column_store_row_groups AS csrg
        ON i.object_id = csrg.object_id
           AND i.index_id = csrg.index_id
WHERE name = 'cci_bigTransactionHistory'
ORDER BY OBJECT_NAME(i.object_id),
         i.name,
         row_group_id;


--fragmentation
DELETE dbo.bigTransactionHistory
WHERE Quantity = 13;


--rowstore fragmentation overhead
IF (SELECT OBJECT_ID('Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT,
                        C3 INT,
                        c4 CHAR(2000));

CREATE CLUSTERED INDEX i1 ON dbo.Test1 (C1);

WITH Nums
AS (SELECT TOP (10000)
           ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS n
    FROM master.sys.all_columns AS ac1
        CROSS JOIN master.sys.all_columns AS ac2)
INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3,
                       c4)
SELECT n,
       n,
       n,
       'a'
FROM Nums;

WITH Nums
AS (SELECT 1 AS n
    UNION ALL
    SELECT n + 1
    FROM Nums
    WHERE n < 10000)
INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3,
                       c4)
SELECT 10000 - n,
       n,
       n,
       'a'
FROM Nums
OPTION (MAXRECURSION 10000);

--Reads 6 rows
SELECT *
FROM dbo.Test1
WHERE C1 BETWEEN 21
         AND     23;
GO
--Reads all rows
SELECT *
FROM dbo.Test1
WHERE C1 BETWEEN 1
         AND     10000;
GO


ALTER INDEX i1 ON dbo.Test1 REBUILD;

--columnstore fragmentation overhead
SELECT bth.Quantity,
       AVG(bth.ActualCost)
FROM dbo.bigTransactionHistory AS bth
WHERE bth.Quantity BETWEEN 8
                   AND     15
GROUP BY bth.Quantity;

/*
70ms
20932
*/

DELETE dbo.bigTransactionHistory
WHERE Quantity BETWEEN 9
               AND     12;

/*79ms
20390
*/

--analyzing fragmentation
SELECT ddips.avg_fragmentation_in_percent,
       ddips.fragment_count,
       ddips.page_count,
       ddips.avg_page_space_used_in_percent,
       ddips.record_count,
       ddips.avg_record_size_in_bytes
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'dbo.Test1'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS ddips;


SELECT ddips.*
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'dbo.Test1'),
                                    NULL,
                                    NULL,
                                    'Detailed') AS ddips;

--small table
IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO

CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT,
                        C3 INT,
                        C4 CHAR(2000));

DECLARE @n INT = 1;

WHILE @n <= 28
BEGIN
    INSERT INTO dbo.Test1
    VALUES (@n, @n, @n, 'a');
    SET @n = @n + 1;
END

CREATE CLUSTERED INDEX FirstIndex ON dbo.Test1 (C1);


--drop existing
CREATE UNIQUE CLUSTERED INDEX FirstIndex
ON dbo.Test1
(
    C1
)
WITH (DROP_EXISTING = ON);


--Index rebuild
IF (SELECT OBJECT_ID('Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT,
                        C3 INT,
                        c4 CHAR(2000));

CREATE CLUSTERED INDEX i1 ON dbo.Test1 (C1);

WITH Nums
AS (SELECT TOP (10000)
           ROW_NUMBER() OVER (ORDER BY (SELECT 1)) AS n
    FROM master.sys.all_columns AS ac1
        CROSS JOIN master.sys.all_columns AS ac2)
INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3,
                       c4)
SELECT n,
       n,
       n,
       'a'
FROM Nums;

WITH Nums
AS (SELECT 1 AS n
    UNION ALL
    SELECT n + 1
    FROM Nums
    WHERE n < 10000)
INSERT INTO dbo.Test1 (C1,
                       C2,
                       C3,
                       c4)
SELECT 10000 - n,
       n,
       n,
       'a'
FROM Nums
OPTION (MAXRECURSION 10000);



ALTER INDEX i1 ON dbo.Test1 REBUILD;


SELECT ddips.avg_fragmentation_in_percent,
       ddips.fragment_count,
       ddips.page_count,
       ddips.avg_page_space_used_in_percent,
       ddips.record_count,
       ddips.avg_record_size_in_bytes
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'dbo.Test1'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS ddips;


--online
ALTER INDEX i1 ON dbo.Test1 REBUILD WITH (ONLINE = ON, RESUMABLE = ON);





--reorganize
ALTER INDEX i1 ON dbo.Test1 REORGANIZE;


ALTER INDEX cci_bigTransactionHistory
ON dbo.bigTransactionHistory
REORGANIZE;

SELECT OBJECT_NAME(i.object_id) AS TableName,
       i.name AS IndexName,
       csrg.partition_number,
       csrg.row_group_id,
       csrg.state_description,
       csrg.total_rows,
       csrg.deleted_rows,
       100 * (total_rows - ISNULL(deleted_rows,
                                  0)) / total_rows AS PercentFull
FROM sys.indexes AS i
    JOIN sys.column_store_row_groups AS csrg
        ON i.object_id = csrg.object_id
           AND i.index_id = csrg.index_id
WHERE name = 'cci_bigTransactionHistory'
ORDER BY OBJECT_NAME(i.object_id),
         i.name,
         row_group_id;


ALTER INDEX cci_bigTransactionHistory
ON dbo.bigTransactionHistory
REORGANIZE
WITH (COMPRESS_ALL_ROW_GROUPS = ON);


ALTER INDEX cci_bigTransactionHistory
ON dbo.bigTransactionHistory
REBUILD;

DELETE dbo.bigTransactionHistory
WHERE Quantity BETWEEN 8
               AND     17;

DELETE dbo.bigTransactionHistory
WHERE Quantity BETWEEN 6
               AND     8;


--partition
ALTER INDEX i1 ON dbo.Test1 
REBUILD PARTITION = ALL
WITH (ONLINE = ON);


ALTER INDEX i1 ON dbo.Test1 
REBUILD PARTITION = 1
WITH (ONLINE = ON);

ALTER INDEX i1
ON dbo.Test1
REBUILD PARTITION = 1
WITH (ONLINE = ON (WAIT_AT_LOW_PRIORITY (MAX_DURATION = 20,
                                         ABORT_AFTER_WAIT = SELF)));


--fill factor
IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 CHAR(999));

WITH Nums
AS (SELECT 1 AS n
    UNION ALL
    SELECT n + 1
    FROM Nums
    WHERE n < 24)
INSERT INTO dbo.Test1 (C1,
                       C2)
SELECT n * 100,
       'a'
FROM Nums;


CREATE CLUSTERED INDEX FillIndex ON Test1 (C1);

SELECT ddips.avg_fragmentation_in_percent,
       ddips.fragment_count,
       ddips.page_count,
       ddips.avg_page_space_used_in_percent,
       ddips.record_count,
       ddips.avg_record_size_in_bytes
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'dbo.Test1'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS ddips;

ALTER INDEX FillIndex ON dbo.Test1 REBUILD WITH (FILLFACTOR = 75);

INSERT INTO dbo.Test1
VALUES (110, 'a'), --25th row     
       (120, 'a'); --26th row

INSERT INTO dbo.Test1
VALUES (130, 'a'); --27th row




--Chapter 15
/*CREATE TABLE dbo.Test1 (c1 INT);
INSERT  INTO dbo.Test1
VALUES  (1);
CEILEKT * FROM dbo.t1; --Error:  I meant,  SELECT * FROM t1
*/


IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT);
INSERT INTO dbo.Test1
VALUES (1);
SELECT 'Before Error',
       C1
FROM dbo.Test1 AS t;
SELECT 'error',
       c1
FROM dbo.no_Test1;
--Error:  Table doesn't exist 
SELECT 'after error' AS c1
FROM dbo.Test1 AS t;



SELECT soh.AccountNumber,
       soh.OrderDate,
       soh.PurchaseOrderNumber,
       soh.SalesOrderNumber
FROM Sales.SalesOrderHeader AS soh
WHERE soh.SalesOrderID BETWEEN 62500
                       AND     62550;

SELECT soh.SalesOrderNumber,
       sod.OrderQty,
       sod.LineTotal,
       sod.UnitPrice,
       sod.UnitPriceDiscount,
       p.Name AS ProductName,
       p.ProductNumber,
       ps.Name AS ProductSubCategoryName,
       pc.Name AS ProductCategoryName
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product AS p
        ON sod.ProductID = p.ProductID
    JOIN Production.ProductModel AS pm
        ON p.ProductModelID = pm.ProductModelID
    JOIN Production.ProductSubcategory AS ps
        ON p.ProductSubcategoryID = ps.ProductSubcategoryID
    JOIN Production.ProductCategory AS pc
        ON ps.ProductCategoryID = pc.ProductCategoryID
WHERE soh.CustomerID = 29658;



SELECT deqoi.counter,
       deqoi.occurrence,
       deqoi.value
FROM sys.dm_exec_query_optimizer_info AS deqoi;


USE master;
EXEC sp_configure 'show advanced option', '1';
RECONFIGURE;
ALTER SERVER CONFIGURATION SET PROCESS AFFINITY CPU = 0 TO 3;
GO

USE master;
EXEC sp_configure 'show advanced option','1';
RECONFIGURE;
EXEC sp_configure 'max degree of parallelism',2;
RECONFIGURE;

SELECT  *
FROM    dbo.t1
WHERE   C1 = 1
OPTION  (MAXDOP 2);

USE master;
EXEC sp_configure 'show advanced option','1';
RECONFIGURE;
EXEC sp_configure 'cost threshold for parallelism',35;
RECONFIGURE;




--Chapter 16
SELECT decp.refcounts,
       decp.usecounts,
       decp.size_in_bytes,
       decp.cacheobjtype,
       decp.objtype,
       decp.plan_handle
FROM sys.dm_exec_cached_plans AS decp;

--Plan reuse
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = 29690
      AND sod.ProductID = 711;

GO

CREATE OR ALTER PROC dbo.BasicSalesInfo
    @ProductID INT,
    @CustomerID INT
AS
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = @CustomerID
      AND sod.ProductID = @ProductID;


DECLARE @Planhandle VARBINARY(64);

SELECT @Planhandle = deqs.plan_handle
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.sql_handle) AS dest
WHERE dest.text LIKE '%SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = 29690
      AND sod.ProductID = 711;%'

IF @Planhandle IS NOT NULL
BEGIN
    DBCC FREEPROCCACHE(@Planhandle);
END
GO




EXEC sp_configure 'show advanced option', '1';
GO
RECONFIGURE
GO
EXEC sp_configure 'optimize for ad hoc workloads', 0;
GO
RECONFIGURE;




--ad hoc workloads
SELECT c.usecounts,
       c.cacheobjtype,
       c.objtype
FROM sys.dm_exec_cached_plans AS c
    CROSS APPLY sys.dm_exec_sql_text(c.plan_handle) AS t
WHERE t.text = 'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = 29690
      AND sod.ProductID = 711;';


SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = 29500
      AND sod.ProductID = 711;


SELECT  c.usecounts,
        c.cacheobjtype,
        c.objtype,
        t.text,
        --c.plan_handle,
		c.size_in_bytes    
FROM    sys.dm_exec_cached_plans c
CROSS APPLY sys.dm_exec_sql_text(c.plan_handle) t
WHERE   t.text LIKE 'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID%';

EXEC sp_configure 'show advanced option', '1';
GO
RECONFIGURE
GO
EXEC sp_configure 'optimize for ad hoc workloads', 1;
GO
RECONFIGURE;


DBCC FREEPROCCACHE
GO
USE AdventureWorks2017;

SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = 29690
      AND sod.ProductID = 711;


EXEC sp_configure 'optimize for ad hoc workloads', 0;
GO
RECONFIGURE;
GO
EXEC sp_configure 'show advanced option', '0';
GO
RECONFIGURE;

--simple parameterization
GO
USE AdventureWorks2017

SELECT *
FROM Person.Address AS a
WHERE a.AddressID = 42;

DBCC FREEPROCCACHE

ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE

SELECT c.usecounts,
       c.cacheobjtype,
       c.objtype,
       t.text
FROM sys.dm_exec_cached_plans AS c
    CROSS APPLY sys.dm_exec_sql_text(c.plan_handle) AS t
WHERE t.text LIKE '%>=%';


SELECT *
FROM Person.Address AS a
WHERE a.AddressID = 42000;

SELECT *
FROM Person.Address AS a
WHERE a.AddressID = 52;


SELECT a.*
FROM Person.Address AS a
WHERE a.AddressID BETWEEN 40
                  AND     60;

SELECT  a.*
FROM    Person.Address AS a
WHERE   a.AddressID >= 40
        AND a.AddressID <= 60;


--forced parameterization
ALTER DATABASE AdventureWorks2017 SET PARAMETERIZATION FORCED;

ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;

DBCC FREEPROCCACHE


SELECT ea.EmailAddress,
       e.BirthDate,
       a.City
FROM Person.Person AS p
    JOIN HumanResources.Employee AS e
        ON p.BusinessEntityID = e.BusinessEntityID
    JOIN Person.BusinessEntityAddress AS bea
        ON e.BusinessEntityID = bea.BusinessEntityID
    JOIN Person.Address AS a
        ON bea.AddressID = a.AddressID
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
    JOIN Person.EmailAddress AS ea
        ON p.BusinessEntityID = ea.BusinessEntityID
WHERE ea.EmailAddress LIKE 'david%'
      AND sp.StateProvinceCode = 'WA';


SELECT c.usecounts,
       c.cacheobjtype,
       c.objtype,
       t.text
FROM sys.dm_exec_cached_plans AS c
    CROSS APPLY sys.dm_exec_sql_text(c.plan_handle) AS t


ALTER DATABASE AdventureWorks2017 SET PARAMETERIZATION SIMPLE;



GO
--procedures
CREATE OR ALTER PROC dbo.BasicSalesInfo
    @ProductID INT,
    @CustomerID INT
AS
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = @CustomerID
      AND sod.ProductID = @ProductID;



EXEC dbo.BasicSalesInfo @CustomerID = 29690, @ProductID = 711;

DECLARE @PlanHandle VARBINARY(64);

SELECT  @PlanHandle = deps.plan_handle
FROM    sys.dm_exec_procedure_stats AS deps
WHERE   deps.object_id = OBJECT_ID('dbo.BasicSalesInfo');

IF @PlanHandle IS NOT NULL
    BEGIN
        DBCC FREEPROCCACHE(@PlanHandle);
    END
GO


EXEC dbo.BasicSalesInfo @CustomerID = 29690, @ProductID = 777;
GO



CREATE OR ALTER PROCEDURE dbo.MyNewProc
AS
SELECT MyID
FROM dbo.NotHere; --Table dbo.NotHere doesn't exist



IF (SELECT OBJECT_ID('dbo.RestrictedAccess')) IS NOT NULL
    DROP TABLE dbo.RestrictedAccess;
GO
CREATE TABLE dbo.RestrictedAccess (ID INT,
                                   Status VARCHAR(7));
INSERT INTO t1
VALUES (1, 'New');
GO
IF (SELECT OBJECT_ID('dbo.MarkDeleted')) IS NOT NULL
    DROP PROCEDURE dbo.MarkDeleted;
GO
CREATE PROCEDURE dbo.MarkDeleted @ID INT
AS
UPDATE dbo.RestrictedAccess
SET Status = 'Deleted'
WHERE ID = @ID;
GO

--Prevent user u1 from deleting rows 
DENY DELETE ON dbo.RestrictedAccess TO  UserOne;

--Allow user u1 to mark a row as 'deleted' 
GRANT EXECUTE ON dbo.MarkDeleted TO UserOne;




CREATE PROCEDURE dbo.MarkDeleted @ID INT
AS
DECLARE @SQL NVARCHAR(MAX);

SET @SQL = 'UPDATE  dbo.RestrictedAccess
SET     Status = ''Deleted''
WHERE   ID = ' + @ID;

EXEC sys.sp_executesql @SQL;
GO

GRANT EXECUTE ON dbo.MarkDeleted TO UserOne;




--sp_executesql


DECLARE @query NVARCHAR(MAX),
        @paramlist NVARCHAR(MAX);

SET @query
    = N'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = @CustomerID
      AND sod.ProductID = @ProductID';

SET @paramlist = N'@CustomerID INT, @ProductID INT';

EXEC sp_executesql @query,
                   @paramlist,
                   @CustomerID = 29690,
                   @ProductID = 711;



SELECT c.usecounts,
       c.cacheobjtype,
       c.objtype,
       t.text
FROM sys.dm_exec_cached_plans AS c
    CROSS APPLY sys.dm_exec_sql_text(c.plan_handle) AS t
WHERE text LIKE '(@CustomerID%';



DECLARE @query NVARCHAR(MAX),
        @paramlist NVARCHAR(MAX);

SET @query
    = N'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = @CustomerID
      AND sod.ProductID = @ProductID';

SET @paramlist = N'@CustomerID INT, @ProductID INT';

EXEC sp_executesql @query,
                   @paramlist,
                   @CustomerID = 29690,
                   @ProductID = 777;


DECLARE @query NVARCHAR(MAX),
        @paramlist NVARCHAR(MAX);


SET @query
    = N'SELECT    soh.SalesOrderNumber ,soh.OrderDate ,sod.OrderQty ,sod.LineTotal FROM       Sales.SalesOrderHeader AS soh JOIN Sales.SalesOrderDetail AS sod ON soh.SalesOrderID = sod.SalesOrderID where      soh.CustomerID = @CustomerID AND sod.ProductID = @ProductID';

SET @paramlist = N'@CustomerID INT, @ProductID INT';

EXEC sp_executesql @query,
                   @paramlist,
                   @CustomerID = 29690,
                   @ProductID = 777;


SELECT decp.usecounts,
       decp.cacheobjtype,
       decp.objtype,
       dest.text,
       deqs.creation_time,
       deqs.execution_count,
       deqs.query_hash,
       deqs.query_plan_hash
FROM sys.dm_exec_cached_plans AS decp
    CROSS APPLY sys.dm_exec_sql_text(decp.plan_handle) AS dest
    JOIN sys.dm_exec_query_stats AS deqs
        ON decp.plan_handle = deqs.plan_handle
WHERE dest.text LIKE '(@CustomerID INT, @ProductID INT)%';




--query hash
SELECT *
FROM Production.Product AS p
    JOIN Production.ProductSubcategory AS ps
        ON p.ProductSubcategoryID = ps.ProductSubcategoryID
    JOIN Production.ProductCategory AS pc
        ON ps.ProductCategoryID = pc.ProductCategoryID
WHERE pc.Name = 'Bikes'
      AND ps.Name = 'Touring Bikes';

SELECT *
FROM Production.Product AS p
    JOIN Production.ProductSubcategory AS ps
        ON p.ProductSubcategoryID = ps.ProductSubcategoryID
    JOIN Production.ProductCategory AS pc
        ON ps.ProductCategoryID = pc.ProductCategoryID
where pc.Name = 'Bikes'
      and ps.Name = 'Road Bikes';



SELECT deqs.execution_count,
       deqs.query_hash,
       deqs.query_plan_hash,
       dest.text
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.plan_handle) AS dest
WHERE dest.text LIKE '%FROM Production.Product AS p
    JOIN Production.ProductSubcategory AS ps
        ON p.ProductSubcategoryID = ps.ProductSubcategoryID
%';




SELECT p.ProductID
FROM Production.Product AS p
    JOIN Production.ProductSubcategory AS ps
        ON p.ProductSubcategoryID = ps.ProductSubcategoryID
    JOIN Production.ProductCategory AS pc
        ON ps.ProductCategoryID = pc.ProductCategoryID
WHERE pc.Name = 'Bikes'
      AND ps.Name = 'Touring Bikes';




SELECT p.Name,
       tha.TransactionDate,
       tha.TransactionType,
       tha.Quantity,
       tha.ActualCost
FROM Production.TransactionHistoryArchive AS tha
    JOIN Production.Product AS p
        ON tha.ProductID = p.ProductID
WHERE p.ProductID = 461;


SELECT p.Name,
       tha.TransactionDate,
       tha.TransactionType,
       tha.Quantity,
       tha.ActualCost
FROM Production.TransactionHistoryArchive AS tha
    JOIN Production.Product AS p
        ON tha.ProductID = p.ProductID
WHERE p.ProductID = 712;

SELECT deqs.execution_count,
       deqs.query_hash,
       deqs.query_plan_hash,
       dest.text
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.plan_handle) AS dest
WHERE dest.text LIKE 'SELECT p.Name,
       tha.%';


--ad hoc
DECLARE @n VARCHAR(3) = '776',
        @sql VARCHAR(MAX);

SET @sql
    = 'SELECT * FROM Sales.SalesOrderDetail sod  ' + 'JOIN Sales.SalesOrderHeader soh  '
      + 'ON sod.SalesOrderID=soh.SalesOrderID ' + 'WHERE    sod.ProductID=''' + @n + '''';

--Execute the dynamic query using EXECUTE statement 
EXECUTE (@sql);



SELECT deqs.execution_count,
       deqs.query_hash,
       deqs.query_plan_hash,
       dest.text,
       deqp.query_plan
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.plan_handle) AS dest
    CROSS APPLY sys.dm_exec_query_plan(deqs.plan_handle) AS deqp
WHERE dest.text LIKE 'SELECT * FROM Sales.SalesOrderDetail sod%';

DECLARE @n NVARCHAR(3) = '776',
        @sql NVARCHAR(MAX),
        @paramdef NVARCHAR(6);

SET @sql
    = 'SELECT * FROM Sales.SalesOrderDetail sod  ' + 'JOIN Sales.SalesOrderHeader soh  '
      + 'ON sod.SalesOrderID=soh.SalesOrderID ' + 'WHERE    sod.ProductID=@1';
SET @paramdef = N'@1 INT';

--Execute the dynamic query using sp_executesql system stored procedure 
EXECUTE sp_executesql @sql, @paramdef, @1 = @n;

USE AdventureWorks2017
go
--Chapter 17

--difference between parameters and variables

CREATE PROCEDURE dbo.ProductDetails (@ProductID INT)
AS
DECLARE @CurrentDate DATETIME = GETDATE();

SELECT p.Name,
       p.Color,
       p.DaysToManufacture,
       pm.CatalogDescription
FROM Production.Product AS p
    JOIN Production.ProductModel AS pm
        ON pm.ProductModelID = p.ProductModelID
WHERE p.ProductID = @ProductID
      AND pm.ModifiedDate < @CurrentDate;
GO


--good parameter sniffing
CREATE OR ALTER PROC dbo.AddressByCity @City NVARCHAR(30)
AS
SELECT a.AddressID,
       a.AddressLine1,
       AddressLine2,
       a.City,
       sp.Name AS StateProvinceName,
       a.PostalCode
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.City = @City;
GO

EXEC dbo.AddressByCity @City = N'London';


DECLARE @City NVARCHAR(30) = N'London';

SELECT  a.AddressID,
        a.AddressLine1,
        AddressLine2,
        a.City,
        sp.[Name] AS StateProvinceName,
        a.PostalCode
FROM    Person.Address AS a
JOIN    Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE   a.City = @City;



GO

DECLARE @PlanHandle VARBINARY(64);

SELECT @PlanHandle = deps.plan_handle
FROM sys.dm_exec_procedure_stats AS deps
WHERE deps.object_id = OBJECT_ID('dbo.AddressByCity');

IF @PlanHandle IS NOT NULL
BEGIN
    DBCC FREEPROCCACHE(@PlanHandle);
END
GO



CREATE OR ALTER PROC dbo.AddressByCity @City NVARCHAR(30)
AS
SELECT a.AddressID,
       a.AddressLine1,
       AddressLine2,
       a.City,
       sp.Name AS StateProvinceName,
       a.PostalCode
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.City = @City;
GO

EXEC dbo.AddressByCity @City = N'Mentor';


SELECT deps.execution_count,
       deps.total_elapsed_time,
       deps.total_logical_reads,
       deps.total_logical_writes,
       deqp.query_plan
FROM sys.dm_exec_procedure_stats AS deps
    CROSS APPLY sys.dm_exec_query_plan(deps.plan_handle) AS deqp
WHERE deps.object_id = OBJECT_ID('dbo.AddressByCity');


SELECT SUM(qsrs.count_executions) AS ExecutionCount,
       AVG(qsrs.avg_duration) AS AvgDuration,
       AVG(qsrs.avg_logical_io_reads) AS AvgReads,
       AVG(qsrs.avg_logical_io_writes) AS AvgWrites,
       CAST(qsp.query_plan AS XML) AS Query_Plan,
       qsp.query_id,
       qsp.plan_id
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_plan AS qsp
        ON qsp.query_id = qsq.query_id
    JOIN sys.query_store_runtime_stats AS qsrs
        ON qsrs.plan_id = qsp.plan_id
WHERE qsq.object_id = OBJECT_ID('dbo.AddressByCity')
GROUP BY qsp.query_plan,
         qsp.query_id,
         qsp.plan_id;



ALTER PROC dbo.AddressByCity @City NVARCHAR(30)
AS
DECLARE @LocalCity NVARCHAR(30) = @City;

SELECT a.AddressID,
       a.AddressLine1,
       AddressLine2,
       a.City,
       sp.Name AS StateProvinceName,
       a.PostalCode
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.City = @LocalCity;



CREATE OR ALTER PROC dbo.AddressByCity @City NVARCHAR(30)
AS
SELECT a.AddressID,
       a.AddressLine1,
       AddressLine2,
       a.City,
       sp.Name AS StateProvinceName,
       a.PostalCode
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.City = @City
OPTION (OPTIMIZE FOR (@City = 'Mentor'));




SELECT CAST(qsp.query_plan AS XML) AS query_plan,
       qsp.plan_id,
       qsq.query_id
FROM sys.query_store_plan AS qsp
    JOIN sys.query_store_query AS qsq
        ON qsq.query_id = qsp.query_id
WHERE qsq.object_id = OBJECT_ID('dbo.AddressByCity');


EXEC sys.sp_query_store_force_plan 1545, 1602;


EXEC dbo.AddressByCity @City = N'London';


EXEC sys.sp_query_store_unforce_plan 1545, 1602;


GO






--Chapter 18
--beneficial recompiles

CREATE OR ALTER PROCEDURE dbo.WorkOrder
AS
SELECT wo.WorkOrderID,
       wo.ProductID,
       wo.StockedQty
FROM Production.WorkOrder AS wo
WHERE wo.StockedQty BETWEEN 500
                    AND     700;

GO 

EXEC dbo.WorkOrder

GO


--CREATE INDEX IX_Test ON Production.WorkOrder(StockedQty,ProductID);

GO
--painful recompiles
CREATE OR ALTER PROCEDURE dbo.WorkOrderAll
AS
SELECT *
FROM Production.WorkOrder AS wo;


DROP INDEX Production.WorkOrder.IX_Test;



EXEC dbo.WorkOrderAll;
GO
--CREATE INDEX IX_Test ON Production.WorkOrder (StockedQty, ProductID);
GO
EXEC dbo.WorkOrderAll; --After creation of index IX_Test


GO
--monitoring recompiles
CREATE OR ALTER PROC dbo.TestProc
AS
CREATE TABLE #TempTable (C1 INT);
INSERT INTO #TempTable (C1)
VALUES (42);
-- data change causes recompile 
GO


EXEC dbo.TestProc;



SELECT DATABASEPROPERTYEX('AdventureWorks2017',
                          'IsAutoUpdateStatistics');



IF EXISTS (   SELECT *
              FROM sys.objects AS o
              WHERE o.object_id = OBJECT_ID(N'dbo.NewOrderDetail')
                    AND o.type IN ( N'U' ))
    DROP TABLE dbo.NewOrderDetail;
GO
SELECT *
INTO dbo.NewOrderDetail
FROM Sales.SalesOrderDetail;
GO
CREATE INDEX IX_NewOrders_ProductID ON dbo.NewOrderDetail (ProductID);
GO
IF EXISTS (   SELECT *
              FROM sys.objects
              WHERE object_id = OBJECT_ID(N'dbo.NewOrders')
                    AND type IN ( N'P', N'PC' ))
    DROP PROCEDURE dbo.NewOrders;
GO
CREATE PROCEDURE dbo.NewOrders
AS
SELECT nod.OrderQty,
       nod.CarrierTrackingNumber
FROM dbo.NewOrderDetail AS nod
WHERE nod.ProductID = 897;
GO
SET STATISTICS XML ON;
EXEC dbo.NewOrders;
SET STATISTICS XML OFF;
GO


UPDATE dbo.NewOrderDetail
SET ProductID = 897
WHERE ProductID BETWEEN 800
                AND     900;
GO
SET STATISTICS XML ON;
EXEC dbo.NewOrders;
SET STATISTICS XML OFF;
GO


--table recompiles
IF (SELECT OBJECT_ID('dbo.TestProc')) IS NOT NULL
    DROP PROC dbo.TestProc;
GO
CREATE PROC dbo.TestProc
AS
CREATE TABLE dbo.ProcTest1 (C1 INT); --Ensure table doesn't exist 
SELECT *
FROM dbo.ProcTest1; --Causes recompilation 
DROP TABLE dbo.ProcTest1;
GO

EXEC dbo.TestProc; --First execution 
EXEC dbo.TestProc; --Second execution


--temp table recompile
IF (SELECT OBJECT_ID('dbo.TestProc')) IS NOT NULL
    DROP PROC dbo.TestProc;
GO
CREATE PROC dbo.TestProc
AS
CREATE TABLE #ProcTest1 (C1 INT); --Ensure table doesn't exist 
SELECT *
FROM #ProcTest1; --Causes recompilation 
DROP TABLE #ProcTest1;
GO

EXEC dbo.TestProc; --First execution 
EXEC dbo.TestProc; --Second execution




IF (SELECT OBJECT_ID('dbo.TestProc')) IS NOT NULL
    DROP PROC dbo.TestProc;
GO
CREATE PROC dbo.TestProc
AS
SELECT 'a' + NULL + 'b'; --1st 
SET CONCAT_NULL_YIELDS_NULL OFF;
SELECT 'a' + NULL + 'b'; --2nd 
SET ANSI_NULLS OFF;
SELECT 'a' + NULL + 'b';
--3rd 
GO
EXEC dbo.TestProc; --First execution 
EXEC dbo.TestProc; --Second execution



--request recompile
sp_recompile  'Test1';


--clear the procedure cache
DECLARE @planhandle VARBINARY(64)
SELECT @planhandle = deqs.plan_handle
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(deqs.sql_handle) AS dest
WHERE dest.text LIKE '%SELECT soh.SalesOrderNumber,%'
IF @planhandle IS NOT NULL
    DBCC FREEPROCCACHE(@planhandle);
GO

DECLARE @query NVARCHAR(MAX);
DECLARE @param NVARCHAR(MAX);
SET @query
    = N'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerId;'
SET @param = N'@CustomerId INT';
EXEC sp_executesql @query, @param, @CustomerId = 1;
EXEC sp_executesql @query, @param, @CustomerId = 30118;


GO
--recompile
CREATE OR ALTER PROCEDURE dbo.CustomerList @CustomerId INT
WITH RECOMPILE
AS
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerId;
GO

EXEC CustomerList @CustomerId = 1;
EXEC CustomerList @CustomerId = 30118;


EXEC dbo.CustomerList @CustomerId = 1 WITH RECOMPILE;


GO

CREATE OR ALTER PROCEDURE dbo.CustomerList @CustomerId INT
AS
SELECT a.AddressLine1,
       a.AddressLine2,
       a.City,
       a.PostalCode
FROM Person.Address AS a
    JOIN Sales.SalesOrderHeader AS soh
        ON soh.ShipToAddressID = a.AddressID
WHERE soh.CustomerID = @CustomerId;

SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerId
OPTION (RECOMPILE);

SELECT bom.BillOfMaterialsID,
       p.Name,
       sod.OrderQty
FROM Production.BillOfMaterials AS bom
    JOIN Production.Product AS p
        ON p.ProductID = bom.ProductAssemblyID
    JOIN Sales.SalesOrderDetail AS sod
        ON sod.ProductID = p.ProductID
    JOIN Sales.SalesOrderHeader AS soh
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID = @CustomerId;
GO


IF (SELECT OBJECT_ID('dbo.TempTable')) IS NOT NULL
    DROP PROC dbo.TempTable
GO
CREATE PROC dbo.TempTable
AS
CREATE TABLE #MyTempTable (ID INT,
                           Dsc NVARCHAR(50))
INSERT INTO #MyTempTable (ID,
                          Dsc)
SELECT pm.ProductModelID,
       pm.Name
FROM Production.ProductModel AS pm; --Needs 1st recompilation
SELECT *
FROM #MyTempTable AS mtt;
CREATE CLUSTERED INDEX iTest ON #MyTempTable (ID);
SELECT *
FROM #MyTempTable AS mtt; --Needs 2nd recompilation
CREATE TABLE #t2 (c1 INT);
SELECT *
FROM #t2;
--Needs 3rd recompilation 
GO

EXEC dbo.TempTable; --First execution



--Create a small table with one row and an index 
IF (SELECT OBJECT_ID('dbo.Test1')) IS NOT NULL
    DROP TABLE dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 CHAR(50));
INSERT INTO dbo.Test1
VALUES (1, '2');
CREATE NONCLUSTERED INDEX IndexOne ON dbo.Test1 (C1);
GO
--Create a stored procedure referencing the previous table 
CREATE OR ALTER PROC dbo.TestProc
AS
SELECT *
FROM dbo.Test1 AS t
WHERE t.C1 = 1
OPTION (KEEPFIXED PLAN);
GO

--First execution of stored procedure with 1 row in the table 
EXEC dbo.TestProc;
--First execution

--Add many rows to the table to cause statistics change 
WITH Nums
AS (SELECT 1 AS n
    UNION ALL
    SELECT n + 1
    FROM Nums
    WHERE n < 1000)
INSERT INTO dbo.Test1 (C1,
                       C2)
SELECT 1,
       n
FROM Nums
OPTION (MAXRECURSION 1000);
GO
--Reexecute the stored procedure with a change in statistics 
EXEC dbo.TestProc; --With change in data distribution


GO
--table variables
CREATE OR ALTER PROC dbo.TestProc
AS
CREATE TABLE #TempTable (C1 INT);
INSERT INTO #TempTable (C1)
VALUES (42);
-- data change causes recompile 
GO

EXEC dbo.TestProc; --First execution

GO
CREATE OR ALTER PROC dbo.TestProc
AS
DECLARE @TempTable TABLE (C1 INT);
INSERT INTO @TempTable (C1)
VALUES (42);
--Recompilation not needed
GO

EXEC dbo.TestProc; --First execution



GO

--hints
CREATE OR ALTER PROCEDURE dbo.CustomerList @CustomerID INT
AS
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerID
OPTION (OPTIMIZE FOR (@CustomerID = 1));
GO



EXEC dbo.CustomerList 
    @CustomerID = 7920 
    WITH RECOMPILE; 
EXEC dbo.CustomerList 
    @CustomerID = 30118 
    WITH RECOMPILE;



GO
CREATE OR ALTER PROCEDURE dbo.CustomerList @CustomerID INT
AS
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerID;
GO

ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE

--plan guide 1
sp_create_plan_guide @name = N'MyGuide',
                     @stmt = N'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= @CustomerID;',
                     @type = N'OBJECT',
                     @module_or_batch = N'dbo.CustomerList',
                     @params = NULL,
                     @hints = N'OPTION (OPTIMIZE FOR (@CustomerID = 1))';


EXEC dbo.CustomerList @CustomerID = 7920 WITH RECOMPILE;
EXEC dbo.CustomerList @CustomerID = 30118 WITH RECOMPILE;


--plan guide 2
SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= 1;


EXECUTE sp_create_plan_guide @name = N'MyBadSQLGuide',
                             @stmt = N'SELECT  soh.SalesOrderNumber,
        soh.OrderDate,
        sod.OrderQty,
        sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
join Sales.SalesOrderDetail AS sod
ON soh.SalesOrderID = sod.SalesOrderID
WHERE   soh.CustomerID >= @CustomerID',
                             @type = N'SQL',
                             @module_or_batch = NULL,
                             @params = N'@CustomerID int',
                             @hints = N'OPTION  (TABLE HINT(soh,  FORCESEEK))';


EXECUTE sp_control_plan_guide @operation = 'Drop',
                              @name = N'MyBadSQLGuide';



EXECUTE sp_create_plan_guide @name = N'MyGoodSQLGuide',
                             @stmt = N'SELECT soh.SalesOrderNumber,
       soh.OrderDate,
       sod.OrderQty,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE soh.CustomerID >= 1;',
                             @type = N'SQL',
                             @module_or_batch = NULL,
                             @params = NULL,
                             @hints = N'OPTION  (TABLE HINT(soh,  FORCESEEK))';


EXECUTE sp_control_plan_guide @operation = 'Drop',
                              @name = N'MyGoodSQLGuide';


DBCC FREEPROCCACHE

DECLARE @plan_handle VARBINARY(64),
        @start_offset INT;

SELECT @plan_handle = deqs.plan_handle,
       @start_offset = deqs.statement_start_offset
FROM sys.dm_exec_query_stats AS deqs
    CROSS APPLY sys.dm_exec_sql_text(sql_handle)
    CROSS APPLY sys.dm_exec_text_query_plan(deqs.plan_handle,
                                            deqs.statement_start_offset,
                                            deqs.statement_end_offset) AS qp
WHERE text LIKE N'SELECT soh.SalesOrderNumber%'

EXECUTE sp_create_plan_guide_from_handle @name = N'ForcedPlanGuide',
                                         @plan_handle = @plan_handle,
                                         @statement_start_offset = @start_offset;
GO

EXECUTE sys.sp_control_plan_guide @operation = N'Drop', -- nvarchar(60)
                                  @name = 'ForcedPlanGuide'      -- sysname



--Chapter 19
--limit data set

SELECT Name,
       TerritoryID
FROM Sales.SalesTerritory AS st
WHERE st.Name = 'Australia';


SELECT *
FROM Sales.SalesTerritory AS st
WHERE st.Name = 'Australia';


--OR, IN and BETWEEN
SELECT sod.*
FROM Sales.SalesOrderDetail AS sod
WHERE sod.SalesOrderID IN ( 51825, 51826, 51827, 51828 );

SELECT sod.*
FROM Sales.SalesOrderDetail AS sod
WHERE sod.SalesOrderID = 51825
      OR sod.SalesOrderID = 51826
      OR sod.SalesOrderID = 51827
      OR sod.SalesOrderID = 51828;

SELECT  sod.*
FROM    Sales.SalesOrderDetail AS sod
WHERE   sod.SalesOrderID BETWEEN 51825 AND 51828;


--LIKE
SELECT c.CurrencyCode
FROM Sales.Currency AS c
WHERE c.Name LIKE 'Ice%';


SELECT c.CurrencyCode
FROM Sales.Currency AS c
WHERE c.Name >= N'Ice'
      AND c.Name < N'IcF';


--!< and >=
SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID >= 2975;
SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID !< 2975;

--Arithmatic
SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID * 2 = 3400;

SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID = 3400 / 2;



--Functions
SELECT d.Name
FROM HumanResources.Department AS d
WHERE SUBSTRING(d.Name,
                1,
                1) = 'F';


SELECT d.Name
FROM HumanResources.Department AS d
WHERE d.Name LIKE 'F%';



--Dates

IF EXISTS (   SELECT *
              FROM sys.indexes
              WHERE object_id = OBJECT_ID(N'[Sales].[SalesOrderHeader]')
                    AND name = N'IndexTest')
    DROP INDEX IndexTest ON Sales.SalesOrderHeader;
GO
CREATE INDEX IndexTest ON Sales.SalesOrderHeader (OrderDate);

SELECT soh.SalesOrderID,
       soh.OrderDate
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE DATEPART(yy,
               soh.OrderDate) = 2008
      AND DATEPART(mm,
                   soh.OrderDate) = 4;



SELECT  soh.SalesOrderID,
        soh.OrderDate
FROM    Sales.SalesOrderHeader AS soh
JOIN    Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
WHERE   soh.OrderDate >= '2008-04-01'
        AND soh.OrderDate < '2008-05-01';



DROP INDEX Sales.SalesOrderHeader.IndexTest;


--scalar udf
CREATE OR ALTER FUNCTION dbo.ProductCost (@ProductID INT)
RETURNS MONEY
AS
BEGIN
	DECLARE @Cost MONEY
    SELECT TOP 1
           @Cost = pch.StandardCost
    FROM Production.ProductCostHistory AS pch
    WHERE pch.ProductID = @ProductID
    ORDER BY pch.StartDate DESC;

	IF @Cost IS NULL
		SET @Cost = 0

	RETURN @Cost
END

SELECT p.Name,
       dbo.ProductCost(p.ProductID)
FROM Production.Product AS p
WHERE p.ProductNumber LIKE 'HL%';
--GO 20


SELECT p.Name,
       pc.StandardCost
FROM Production.Product AS p
    CROSS APPLY
(   SELECT TOP 1
           pch.StandardCost
    FROM Production.ProductCostHistory AS pch
    WHERE pch.ProductID = p.ProductID
    ORDER BY pch.StartDate DESC) AS pc
WHERE p.ProductNumber LIKE 'HL%';
--GO 20

SELECT CAST(qsp.query_plan AS XML)
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_plan AS qsp
        ON qsp.query_id = qsq.query_id
WHERE qsq.object_id = OBJECT_ID('dbo.ProductCost');



--JOIN HINt
SELECT s.Name AS StoreName,
       p.LastName + ', ' + p.FirstName
FROM Sales.Store AS s
    JOIN Sales.SalesPerson AS sp
        ON s.SalesPersonID = sp.BusinessEntityID
    JOIN HumanResources.Employee AS e
        ON sp.BusinessEntityID = e.BusinessEntityID
    JOIN Person.Person AS p
        ON e.BusinessEntityID = p.BusinessEntityID;


SELECT s.Name AS StoreName,
       p.LastName + ',   ' + p.FirstName
FROM Sales.Store AS s
    JOIN Sales.SalesPerson AS sp
        ON s.SalesPersonID = sp.BusinessEntityID
    JOIN HumanResources.Employee AS e
        ON sp.BusinessEntityID = e.BusinessEntityID
    JOIN Person.Person AS p
        ON e.BusinessEntityID = p.BusinessEntityID
OPTION (LOOP JOIN);


SELECT s.Name AS StoreName,
       p.LastName + ',   ' + p.FirstName
FROM Sales.Store AS s
    INNER LOOP JOIN Sales.SalesPerson AS sp
        ON s.SalesPersonID = sp.BusinessEntityID
    JOIN HumanResources.Employee AS e
        ON sp.BusinessEntityID = e.BusinessEntityID
    JOIN Person.Person AS p
        ON e.BusinessEntityID = p.BusinessEntityID;


--JOIN Hints

SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID * 2 = 3400;

SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh
WHERE poh.PurchaseOrderID = 3400 / 2;

SELECT *
FROM Purchasing.PurchaseOrderHeader AS poh WITH (INDEX(PK_PurchaseOrderHeader_PurchaseOrderID))
WHERE poh.PurchaseOrderID * 2 = 3400;


--NULL

SELECT p.FirstName
FROM Person.Person AS p
WHERE p.FirstName < 'B'
      OR p.FirstName >= 'C';

SELECT p.MiddleName
FROM Person.Person AS p
WHERE p.MiddleName < 'B'
      OR p.MiddleName >= 'C';


--query1
SELECT p.FirstName
FROM Person.Person AS p
WHERE p.FirstName < 'B'
      OR p.FirstName >= 'C';

--query2
SELECT p.MiddleName
FROM Person.Person AS p
WHERE p.MiddleName < 'B'
      OR p.MiddleName >= 'C'
      OR p.MiddleName IS NULL;



CREATE INDEX TestIndex1 ON Person.Person (MiddleName);

CREATE INDEX TestIndex2 ON Person.Person (FirstName);


DROP INDEX TestIndex1 ON Person.Person;

DROP INDEX TestIndex2 ON Person.Person;


--Foreign key
IF EXISTS (   SELECT *
              FROM sys.foreign_keys
              WHERE object_id = OBJECT_ID(N'[Person].[FK_Address_StateProvince_StateProvinceID]')
                    AND parent_object_id = OBJECT_ID(N'[Person].[Address]'))
    ALTER TABLE Person.Address
    DROP CONSTRAINT FK_Address_StateProvince_StateProvinceID;



SELECT a.AddressID,
       sp.StateProvinceID
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.AddressID = 27234;


SELECT a.AddressID,
       a.StateProvinceID
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON a.StateProvinceID = sp.StateProvinceID
WHERE a.AddressID = 27234;





ALTER TABLE Person.Address WITH CHECK
ADD CONSTRAINT FK_Address_StateProvince_StateProvinceID
    FOREIGN KEY
    (
        StateProvinceID
    )
    REFERENCES Person.StateProvince
    (
        StateProvinceID
    );



GO
--Chapter 20

--implicit conversion
IF EXISTS (   SELECT *
              FROM sys.objects
              WHERE object_id = OBJECT_ID(N'dbo.Test1'))
    DROP TABLE dbo.Test1;

CREATE TABLE dbo.Test1 (Id INT IDENTITY(1, 1),
                        MyKey VARCHAR(50),
                        MyValue VARCHAR(50));
CREATE UNIQUE CLUSTERED INDEX Test1PrimaryKey ON dbo.Test1 (Id ASC);
CREATE UNIQUE NONCLUSTERED INDEX TestIndex ON dbo.Test1 (MyKey);
GO

SELECT TOP 10000
       IDENTITY(INT, 1, 1) AS n
INTO #Tally
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sc2;

INSERT INTO dbo.Test1 (MyKey,
                       MyValue)
SELECT TOP 10000
       'UniqueKey' + CAST(n AS VARCHAR),
       'Description'
FROM #Tally;

DROP TABLE #Tally;

SELECT t.MyValue
FROM dbo.Test1 AS t
WHERE t.MyKey = 'UniqueKey333';

SELECT t.MyValue
FROM dbo.Test1 AS t
WHERE t.MyKey = N'UniqueKey333';


--exists
DECLARE @n INT;
SELECT @n = COUNT(*)
FROM Sales.SalesOrderDetail AS sod
WHERE sod.OrderQty = 1;
IF @n > 0
    PRINT 'Record Exists';

IF EXISTS (   SELECT sod.*
              FROM Sales.SalesOrderDetail AS sod
              WHERE sod.OrderQty = 1)
    PRINT 'Record Exists';


--union

SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 934
UNION
SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 932
UNION
SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 708;


SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 934
UNION ALL
SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 932
UNION ALL
SELECT sod.ProductID,
       sod.SalesOrderID
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = 708;



--aggregates
SELECT MIN(sod.UnitPrice)
FROM Sales.SalesOrderDetail AS sod;


CREATE INDEX TestIndex ON Sales.SalesOrderDetail (UnitPrice ASC);



--batch

DECLARE @Id INT = 67260;
SELECT  p.Name,
            p.ProductNumber,
            th.ReferenceOrderID
    FROM    Production.Product AS p
    JOIN    Production.TransactionHistory AS th
            ON th.ProductID = p.ProductID
    WHERE   th.ReferenceOrderID = @Id;
--GO 20
SELECT  p.Name,
            p.ProductNumber,
            th.ReferenceOrderID
    FROM    Production.Product AS p
    JOIN    Production.TransactionHistory AS th
            ON th.ProductID = p.ProductID
    WHERE   th.ReferenceOrderID = 67260;
--GO 20



DBCC SHOW_STATISTICS('[Production].[TransactionHistory]',[IX_TransactionHistory_ReferenceOrderID_ReferenceOrderLineID])

SELECT 2.694111E-05 * 113443
GO


CREATE OR ALTER PROCEDURE ProductDetails (@id INT)
AS
SELECT p.Name,
       p.ProductNumber,
       th.ReferenceOrderID
FROM Production.Product AS p
    JOIN Production.TransactionHistory AS th
        ON th.ProductID = p.ProductID
WHERE th.ReferenceOrderID = @id;
GO

EXEC ProductDetails @id = 1;


GO



--naming
CREATE OR ALTER PROC sp_Dont
AS
PRINT 'Done!';
GO
--Add plan of sp_Dont to procedure cache
EXEC AdventureWorks2017.dbo.sp_Dont ; 
GO
--Use the above cached plan of sp_Dont
EXEC AdventureWorks2017.dbo.sp_Dont ; 
GO


DROP PROC sp_addmessage

CREATE OR ALTER PROC sp_addmessage @param1 NVARCHAR(25) 
AS
PRINT  '@param1 =  '  + @param1 ;
GO

EXEC AdventureWorks2017.dbo.[sp_addmessage]   'AdventureWorks';

--atomicity

--Create a test table 

DROP TABLE IF EXISTS dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 TINYINT);
GO

--Insert 10000 rows 
DECLARE @Count INT = 1;
WHILE @Count <= 10000
BEGIN
    INSERT INTO dbo.Test1 (C1)
    VALUES (@Count % 256);
    SET @Count = @Count + 1;
END

GO

DECLARE @Count INT = 1;
DBCC SQLPERF(LOGSPACE);
BEGIN TRANSACTION
WHILE @Count <= 10000
BEGIN
    INSERT INTO dbo.Test1 (C1)
    VALUES (@Count % 256);
    SET @Count = @Count + 1;
END
COMMIT
DBCC SQLPERF(LOGSPACE);


DROP TABLE IF EXISTS #Tally
SELECT TOP 10000
       IDENTITY(INT, 1, 1) AS n
INTO #Tally
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sc2;
DBCC SQLPERF(LOGSPACE);
BEGIN TRANSACTION
INSERT INTO dbo.Test1 (C1)
SELECT TOP 1000
       (n % 256)
FROM #Tally AS t
COMMIT
DBCC SQLPERF(LOGSPACE);

--locking
/*SELECT * FROM <TableName> WITH(PAGLOCK)  --Use page level lock

ALTER DATABASE <DatabaseName> SET READ_ONLY

ALTER DATABASE <DatabaseName> SET READ_WRITE
<Database modifications>
ALTER DATABASE <DatabaseName> SET READONLY*/


ALTER DATABASE AdventureWorks2017 SET READ_COMMITTED_SNAPSHOT ON;


DELETE Sales.SalesOrderDetail
FROM Sales.SalesOrderDetail AS sod WITH (NOLOCK)
    JOIN Production.Product AS p WITH (NOLOCK)
        ON sod.ProductID = p.ProductID
           AND p.ProductID = 0;


--Chapter 21
--atomicity
USE AdventureWorks2017;
GO
DROP TABLE IF EXISTS dbo.ProductTest;
GO
CREATE TABLE dbo.ProductTest (ProductID INT
                                  CONSTRAINT ValueEqualsOne CHECK (ProductID = 1));
GO
--All ProductIDs are added into t1 as a logical unit of work
INSERT INTO dbo.ProductTest
SELECT p.ProductID
FROM Production.Product AS p;
GO
SELECT pt.ProductID
FROM dbo.ProductTest AS pt; --Returns 0 rows



BEGIN TRAN
--Start:  Logical unit of work
--First:
INSERT INTO dbo.ProductTest
SELECT p.ProductID
FROM Production.Product AS p;
--Second:
INSERT INTO dbo.ProductTest
VALUES (1);
COMMIT --End:   Logical unit of work
GO


SELECT  *
FROM    dbo.ProductTest; --Returns a row with t1.c1 = 1

--
--set xact_abort

SET XACT_ABORT ON;
GO
BEGIN TRAN
 --Start:  Logical unit of work
--First:
INSERT  INTO dbo.ProductTest
        SELECT  p.ProductID
        FROM    Production.Product AS p;
--Second:
INSERT  INTO dbo.ProductTest
VALUES  (1);
COMMIT
 --End:   Logical unit of work GO
SET XACT_ABORT OFF;
GO




BEGIN TRY
    BEGIN TRAN
    --Start: Logical unit of work 
    --First:
    INSERT INTO dbo.ProductTest
    SELECT p.ProductID
    FROM Production.Product AS p

    Second:
    INSERT INTO dbo.ProductTest (ProductID)
    VALUES (1)
    COMMIT --End: Logical unit of work 
END TRY
BEGIN CATCH
    ROLLBACK
    PRINT 'An error occurred'
    RETURN
END CATCH



GO
--Locking
--Row locks

--Create a test table
DROP TABLE IF EXISTS dbo.Test1;
CREATE TABLE dbo.Test1 (C1 INT);
INSERT INTO dbo.Test1
VALUES (1);
GO

BEGIN TRAN
DELETE dbo.Test1
WHERE C1 = 1;

SELECT dtl.request_session_id,
       dtl.resource_database_id,
       dtl.resource_associated_entity_id,
       dtl.resource_type,
       dtl.resource_description,
       dtl.request_mode,
       dtl.request_status
FROM sys.dm_tran_locks AS dtl
WHERE dtl.request_session_id = @@SPID;
ROLLBACK

SELECT OBJECT_NAME(1940201962),
       DB_NAME(6);


--key locks
CREATE CLUSTERED INDEX TestIndex ON dbo.Test1 (C1);

BEGIN TRAN
DELETE  dbo.Test1
WHERE   C1 = 1 ;

SELECT dtl.request_session_id,
       dtl.resource_database_id,
       dtl.resource_associated_entity_id,
       dtl.resource_type,
       dtl.resource_description,
       dtl.request_mode,
       dtl.request_status
FROM sys.dm_tran_locks AS dtl
WHERE dtl.request_session_id = @@SPID;
ROLLBACK


--lock modes

--This script goes in one T-SQL Window
BEGIN TRANSACTION LockTran2
--Retain an  (S) lock on the resource
SELECT *
FROM Sales.Currency AS c WITH (REPEATABLEREAD)
WHERE c.CurrencyCode = 'EUR';
--Allow DMVs to be executed before second step of
-- UPDATE statement is executed by transaction LockTran1
WAITFOR DELAY '00:00:10';
COMMIT

--This script goes in a second T-SQL Window
BEGIN TRANSACTION LockTran1
UPDATE Sales.Currency
SET Name = 'Euro'
WHERE CurrencyCode = 'EUR';
--COMMIT


--This script goes in a third T-SQL Window
SELECT  dtl.request_session_id,
        dtl.resource_database_id,
        dtl.resource_associated_entity_id,
        dtl.resource_type,
        dtl.resource_description,
        dtl.request_mode,
        dtl.request_status
FROM    sys.dm_tran_locks AS dtl
ORDER BY dtl.request_session_id;


--X lock
BEGIN TRAN
--1.Read data to be modified using (S)lock instead of (U)lock.
--    Retain the (S)lock using REPEATABLEREAD locking hint, since
--    the original (U)lock is retained until the conversion to
--    (X)lock.
SELECT  *
FROM    Sales.Currency AS c WITH (REPEATABLEREAD)
WHERE   c.CurrencyCode = 'EUR' ;
--Allow another equivalent update action to start concurrently
WAITFOR DELAY '00:00:10' ;

--2. Modify the data by acquiring (X)lock
UPDATE  Sales.Currency WITH (XLOCK)
SET     Name = 'EURO'
WHERE   CurrencyCode = 'EUR' ;
COMMIT


--Other locks
BEGIN TRAN
DELETE Sales.Currency
WHERE CurrencyCode = 'ALL';

SELECT tl.request_session_id,
       tl.resource_database_id,
       tl.resource_associated_entity_id,
       tl.resource_type,
       tl.resource_description,
       tl.request_mode,
       tl.request_status
FROM sys.dm_tran_locks AS tl;

ROLLBACK TRAN



--Isolation levels
ALTER DATABASE AdventureWorks2017 SET READ_COMMITTED_SNAPSHOT ON;



--Run from this connection
BEGIN TRANSACTION;
SELECT  p.Color
FROM    Production.Product AS p
WHERE   p.ProductID = 711;
COMMIT


--run from another connection
BEGIN TRANSACTION ;
UPDATE  Production.Product
SET     Color = 'Coyote'
WHERE   ProductID = 711;
SELECT  p.Color
FROM    Production.Product AS p
WHERE   p.ProductID = 711;

COMMIT


--undo snapshot isolation
ALTER DATABASE AdventureWorks2017 SET READ_COMMITTED_SNAPSHOT OFF;




--Repeatable read

DROP TABLE IF EXISTS dbo.MyProduct;
GO
CREATE TABLE dbo.MyProduct (ProductID INT,
                            Price MONEY);
INSERT INTO dbo.MyProduct
VALUES (1, 15.0);


--Run from this connection
DECLARE @Price INT ;
BEGIN TRAN NormailizePrice
SELECT  @Price = mp.Price
FROM    dbo.MyProduct AS mp
WHERE   mp.ProductID = 1 ;
/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10' ;
IF @Price > 10 
    UPDATE  dbo.MyProduct
    SET     Price = Price - 10
    WHERE   ProductID = 1 ;
COMMIT

--Transaction 2 from Connection 2
BEGIN TRAN ApplyDiscount
UPDATE  dbo.MyProduct
SET     Price = Price * 0.6 --Discount = 40%
WHERE   Price > 10 ;
COMMIT

SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;
GO
--Transaction 1 from Connection 1
DECLARE @Price INT;
BEGIN TRAN NormalizePrice
SELECT @Price = Price
FROM dbo.MyProduct AS mp
WHERE mp.ProductID = 1;
/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10';
IF @Price > 10
    UPDATE dbo.MyProduct
    SET Price = Price - 10
    WHERE ProductID = 1;
COMMIT
GO
SET TRANSACTION ISOLATION LEVEL READ COMMITTED --Back to default
GO


DECLARE @Price INT;
BEGIN TRAN NormalizePrice
SELECT @Price = Price
FROM dbo.MyProduct AS mp WITH (REPEATABLEREAD)
WHERE mp.ProductID = 1;
/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10'
IF @Price > 10
    UPDATE dbo.MyProduct
    SET Price = Price - 10
    WHERE ProductID = 1;
COMMIT

DECLARE @Price INT;
BEGIN TRAN NormalizePrice
SELECT @Price = Price
FROM dbo.MyProduct AS mp WITH (UPDLOCK)
WHERE mp.ProductID = 1;
/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10'
IF @Price > 10
    UPDATE dbo.MyProduct
    SET Price = Price - 10
    WHERE ProductID = 1;
COMMIT



--Serializable
DROP TABLE IF EXISTS dbo.MyEmployees;
GO
CREATE TABLE dbo.MyEmployees (EmployeeID INT,
                              GroupID INT,
                              Salary MONEY);
CREATE CLUSTERED INDEX i1 ON dbo.MyEmployees (GroupID);


--Employee 1 in group 10
INSERT INTO dbo.MyEmployees
VALUES (1, 10, 1000),
       --Employee 2 in group 10
       (2, 10, 1000),
       --Employees 3 & 4 in different groups
       (3, 20, 1000),
       (4, 9, 1000);
GO


DECLARE @Fund MONEY = 100,
    @Bonus MONEY,
    @NumberOfEmployees INT;

BEGIN TRAN PayBonus
SELECT  @NumberOfEmployees = COUNT(*)
FROM    dbo.MyEmployees
WHERE   GroupID = 10;

/*Allow transaction 2 to execute*/
WAITFOR DELAY  '00:00:10';

IF @NumberOfEmployees > 0
    BEGIN
        SET @Bonus = @Fund / @NumberOfEmployees;
        UPDATE  dbo.MyEmployees
        SET     Salary = Salary + @Bonus
        WHERE   GroupID = 10;
        PRINT 'Fund balance =
' + CAST((@Fund - (@@ROWCOUNT * @Bonus)) AS VARCHAR(6)) + '   $';
    END
COMMIT



--2nd connection
BEGIN TRAN NewEmployee
INSERT  INTO MyEmployees
VALUES  (5, 10, 1000);
COMMIT





SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;
GO
DECLARE @Fund MONEY = 100,
        @Bonus MONEY,
        @NumberOfEmployees INT;

BEGIN TRAN PayBonus
SELECT @NumberOfEmployees = COUNT(*)
FROM dbo.MyEmployees
WHERE GroupID = 10;

/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10';
IF @NumberOfEmployees > 0
BEGIN
    SET @Bonus = @Fund / @NumberOfEmployees;
    UPDATE dbo.MyEmployees
    SET Salary = Salary + @Bonus
    WHERE GroupID = 10;

    PRINT 'Fund balance =
' + CAST((@Fund - (@@ROWCOUNT * @Bonus)) AS VARCHAR(6)) + '   $';
END
COMMIT
GO
--Back to default 
SET TRANSACTION ISOLATION LEVEL READ COMMITTED;
GO



DECLARE @Fund MONEY = 100,
        @Bonus MONEY,
        @NumberOfEmployees INT;

BEGIN TRAN PayBonus
SELECT @NumberOfEmployees = COUNT(*)
FROM dbo.MyEmployees WITH (HOLDLOCK)
WHERE GroupID = 10;

/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10';

IF @NumberOfEmployees > 0
BEGIN
    SET @Bonus = @Fund / @NumberOfEmployees
    UPDATE dbo.MyEmployees
    SET Salary = Salary + @Bonus
    WHERE GroupID = 10;

    PRINT 'Fund balance =
' + CAST((@Fund - (@@ROWCOUNT * @Bonus)) AS VARCHAR(6)) + '   $';
END
COMMIT



DECLARE @Fund MONEY = 100,
        @Bonus MONEY,
        @NumberOfEmployees INT;

BEGIN TRAN PayBonus
SELECT @NumberOfEmployees = COUNT(*)
FROM dbo.MyEmployees WITH (HOLDLOCK)
WHERE GroupID = 10;

/*Allow transaction 2 to execute*/
WAITFOR DELAY '00:00:10';

IF @NumberOfEmployees > 0
BEGIN
    SET @Bonus = @Fund / @NumberOfEmployees
    UPDATE dbo.MyEmployees
    SET Salary = Salary + @Bonus
    WHERE GroupID = 10;

    PRINT 'Fund balance =
' + CAST((@Fund - (@@ROWCOUNT * @Bonus)) AS VARCHAR(6)) + '   $';
END
COMMIT


--from a third connection
SELECT dtl.request_session_id,
       dtl.resource_database_id,
       dtl.resource_associated_entity_id,
       dtl.resource_type,
       dtl.resource_description,
       dtl.request_mode,
       dtl.request_status
FROM sys.dm_tran_locks AS dtl;







DROP TABLE IF EXISTS dbo.MyEmployees;
GO
CREATE TABLE dbo.MyEmployees (EmployeeID INT,
                              GroupID INT,
                              Salary MONEY);
CREATE CLUSTERED INDEX i1 ON dbo.MyEmployees (EmployeeID);

--Employee 1 in group 10
INSERT INTO dbo.MyEmployees
VALUES (1, 10, 1000),
       --Employee 2 in group 10
       (2, 10, 1000),
       --Employees 3 & 4 in different groups
       (3, 20, 1000),
       (4, 9, 1000);




--Indexes and locking
DROP TABLE IF EXISTS dbo.Test1;
GO

CREATE TABLE dbo.Test1 (C1 INT,
                        C2 DATETIME);

INSERT INTO dbo.Test1
VALUES (1, GETDATE());




BEGIN TRAN LockBehavior
UPDATE dbo.Test1 WITH (REPEATABLEREAD) --Hold all acquired locks
SET C2 = GETDATE()
WHERE C1 = 1;
--Observe lock behavior from another connection
WAITFOR DELAY '00:00:10';
COMMIT




--nonclustered index
CREATE NONCLUSTERED INDEX iTest ON dbo.Test1(C1);






ALTER INDEX iTest ON dbo.Test1 
    SET (ALLOW_ROW_LOCKS = OFF ,ALLOW_PAGE_LOCKS= OFF);

BEGIN TRAN LockBehavior
UPDATE  dbo.Test1 WITH (REPEATABLEREAD)  --Hold all acquired locks
SET     C2 = GETDATE()
WHERE   C1 = 1;

--Observe lock behavior using sys.dm_tran_locks 
--from another connection
WAITFOR DELAY  '00:00:10';
COMMIT

ALTER INDEX iTest ON dbo.Test1 
    SET (ALLOW_ROW_LOCKS = ON ,ALLOW_PAGE_LOCKS= ON);





CREATE CLUSTERED INDEX iTest ON dbo.Test1(C1) WITH DROP_EXISTING;




BEGIN TRAN SerializableLock
DECLARE @NumberOfEmployees INT;
SELECT  @NumberOfEmployees = COUNT(*)
FROM    dbo.MyEmployees WITH (HOLDLOCK)
WHERE   GroupID = 10;

WAITFOR DELAY  '00:00:10';
COMMIT




--Blocking
SELECT  dtl.request_session_id AS WaitingSessionID,
        der.blocking_session_id AS BlockingSessionID,
        dowt.resource_description,
        der.wait_type,
        dowt.wait_duration_ms,
        DB_NAME(dtl.resource_database_id) AS DatabaseName,
        dtl.resource_associated_entity_id AS WaitingAssociatedEntity,
        dtl.resource_type AS WaitingResourceType,
        dtl.request_type AS WaitingRequestType,
        dest.[text] AS WaitingTSql,
        dtlbl.request_type BlockingRequestType,
        destbl.[text] AS BlockingTsql
FROM    sys.dm_tran_locks AS dtl
JOIN    sys.dm_os_waiting_tasks AS dowt
        ON dtl.lock_owner_address = dowt.resource_address
JOIN    sys.dm_exec_requests AS der
        ON der.session_id = dtl.request_session_id
CROSS APPLY sys.dm_exec_sql_text(der.sql_handle) AS dest
LEFT JOIN sys.dm_exec_requests derbl
        ON derbl.session_id = dowt.blocking_session_id
OUTER APPLY sys.dm_exec_sql_text(derbl.sql_handle) AS destbl
LEFT JOIN sys.dm_tran_locks AS dtlbl
        ON derbl.session_id = dtlbl.request_session_id;





DROP TABLE IF EXISTS dbo.BlockTest;
GO

CREATE TABLE dbo.BlockTest (C1 INT,
                            C2 INT,
                            C3 DATETIME);

INSERT INTO dbo.BlockTest
VALUES (11, 12, GETDATE()),
       (21, 22, GETDATE());


--run from one connction
BEGIN TRAN User1
UPDATE  dbo.BlockTest
SET     C3 = GETDATE();
--COMMIT

--run from another connection
BEGIN TRAN User2
SELECT  C2
FROM    dbo.BlockTest
WHERE   C1 = 11;
COMMIT

SET TRANSACTION ISOLATION LEVEL SNAPSHOT



--Extended Events
EXEC sp_configure 'show advanced option', '1';
RECONFIGURE;
EXEC sp_configure 
    'blocked process threshold',
    5;
RECONFIGURE;





--Chapter 22

DECLARE @path NVARCHAR(260)
--to retrieve the local path of system_health files 
SELECT @path = dosdlc.path
FROM sys.dm_os_server_diagnostics_log_configurations AS dosdlc;

SELECT @path = @path + N'system_health_*';

WITH fxd
AS (SELECT CAST(fx.event_data AS XML) AS Event_Data
    FROM sys.fn_xe_file_target_read_file(@path,
                                         NULL,
                                         NULL,
                                         NULL) AS fx )
SELECT dl.deadlockgraph
FROM
(   SELECT dl.query('.') AS deadlockgraph
    FROM fxd
        CROSS APPLY event_data.nodes('(/event/data/value/deadlock)') AS d(dl) ) AS dl;


SELECT [db_name], [wait_resource], [deadlock_xml] FROM (
    SELECT target_data_XML.query('/event/data[@name=''database_name'']/value').value('(/value)[1]', 'nvarchar(250)') AS [db_name],
    waitresource_node.value('@waitresource', 'nvarchar(250)') AS [wait_resource],
    deadlock_node.query('.') as [deadlock_xml]
    FROM CTE CROSS APPLY target_data_XML.nodes('(/event/data/value/deadlock)') AS T(deadlock_node)
    CROSS APPLY target_data_XML.nodes('(/event/data/value/deadlock/process-list/process)') AS U(waitresource_node)
) deadlock
WHERE [db_name] = '<YourDB>'






BEGIN TRAN
DECLARE @retry AS TINYINT = 1,
        @retrymax AS TINYINT = 2,
        @retrycount AS TINYINT = 0;
WHILE @retry = 1 AND @retrycount <= @retrymax
BEGIN
    SET @retry = 0;

    BEGIN TRY
        UPDATE HumanResources.Employee
        SET LoginID = '54321'
        WHERE BusinessEntityID = 100;
    END TRY
    BEGIN CATCH
        IF (ERROR_NUMBER() = 1205)
        BEGIN
            SET @retrycount = @retrycount + 1;
            SET @retry = 1;
        END
    END CATCH
END
ROLLBACK TRAN




--analyzing a deadlock
--run this statement from one connection
BEGIN TRAN
UPDATE Purchasing.PurchaseOrderHeader
SET Freight = Freight * 0.9 -- 10% discount on shipping
WHERE PurchaseOrderID = 1255;

--go to the second connection and run the script below
--then run this second statement from the first connection
UPDATE Purchasing.PurchaseOrderDetail
SET OrderQty = 2
WHERE ProductID = 448
      AND PurchaseOrderID = 1255;
--ROLLBACK TRAN


--Run this in a second connection
BEGIN TRANSACTION
UPDATE Purchasing.PurchaseOrderDetail
SET OrderQty = 4
WHERE ProductID = 448
      AND PurchaseOrderID = 1255;
--ROLLBACK TRANSACTION





--Chapter 23
-- Cursor example
--Associate a SELECT statement to a cursor and define the
--cursor's characteristics
USE AdventureWorks2017;
GO
SET NOCOUNT ON
DECLARE MyCursor CURSOR /*<cursor characteristics>*/
FOR
SELECT adt.AddressTypeID,
       adt.Name,
       adt.ModifiedDate
FROM Person.AddressType AS adt;


--Open the cursor to access the result set returned by the
--SELECT statement
OPEN MyCursor;

--Retrieve one row at a time from the result set returned by
--the SELECT statement
DECLARE @AddressTypeId INT,
        @Name VARCHAR(50),
        @ModifiedDate DATETIME;

FETCH NEXT FROM MyCursor
INTO @AddressTypeId,
     @Name,
     @ModifiedDate;

WHILE @@FETCH_STATUS = 0
BEGIN
    PRINT 'NAME =   ' + @Name;

    --Optionally, modify the row through the cursor
    UPDATE Person.AddressType
    SET Name = Name + 'z'
    WHERE CURRENT OF MyCursor;

    FETCH NEXT FROM MyCursor
    INTO @AddressTypeId,
         @Name,
         @ModifiedDate;
END

--Close the cursor and release all resources assigned to the
--cursor
CLOSE MyCursor;
DEALLOCATE MyCursor;


--undo those changes
UPDATE Person.AddressType
SET Name = LEFT(Name, LEN(Name) - 1);


--Read Only cursor
DECLARE MyCursor CURSOR READ_ONLY FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--Optimistic cursor
DECLARE MyCursor CURSOR OPTIMISTIC FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--optimistic cursor with scroll_locks
DECLARE MyCursor CURSOR SCROLL_LOCKS FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--firehose cursor
DECLARE MyCursor CURSOR FAST_FORWARD FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--Static cursor
DECLARE MyCursor CURSOR STATIC FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--keyset cursor
DECLARE MyCursor CURSOR KEYSET FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;

--Dynamic Cursor
DECLARE MyCursor CURSOR DYNAMIC FOR
SELECT adt.Name
FROM Person.AddressType AS adt
WHERE adt.AddressTypeID = 1;


--test table
USE AdventureWorks2017;
GO
DROP TABLE IF EXISTS dbo.Test1;
GO

CREATE TABLE dbo.Test1 (C1 INT,
                        C2 CHAR(996));

CREATE CLUSTERED INDEX Test1Index ON dbo.Test1 (C1);

INSERT INTO dbo.Test1
VALUES (1, '1'),
       (2, '2');
GO


/*
powershell

$AdoConn = New-Object -comobject ADODB.Connection
$AdoRecordset = New-Object -comobject ADODB.Recordset

$AdoConn.Open("Provider= SQLOLEDB; Data Source=DOJO\RANDORI; Initial Catalog=AdventureWorks2017; Integrated Security=SSPI")
$AdoRecordset.Open("SELECT * FROM dbo.Test1", $AdoConn)

do {
    $C1 = $AdoRecordset.Fields.Item("C1").Value
    $C2 = $AdoRecordset.Fields.Item("C2").Value
    Write-Output "C1 = $C1 and C2 = $C2"
    $AdoRecordset.MoveNext()
    } until     ($AdoRecordset.EOF -eq $True)
$AdoRecordset.Close()
$AdoConn.Close()


*/


--adding additional rows to the table
SELECT TOP 100000
       IDENTITY(INT, 1, 1) AS n
INTO #Tally
FROM master.dbo.syscolumns AS scl,
     master.dbo.syscolumns AS sc2;

INSERT INTO dbo.Test1 (C1,
                       C2)
SELECT n,
       n
FROM #Tally AS t;
GO



--query to retrieve locks during execution of powershell after loading more data
SELECT dtl.request_session_id,
       dtl.resource_database_id,
       dtl.resource_associated_entity_id,
       dtl.resource_type,
       dtl.resource_description,
       dtl.request_mode,
       dtl.request_status
FROM sys.dm_tran_locks AS dtl;


GO
--Testing cursor behaviors
CREATE OR ALTER PROC dbo.TotalLoss_CursorBased
AS --Declare a T-SQL cursor with default settings,  i.e.,  fast
--forward-only to retrieve products that have been discarded
DECLARE ScrappedProducts CURSOR FOR
SELECT p.ProductID,
       wo.ScrappedQty,
       p.ListPrice
FROM Production.WorkOrder AS wo
    JOIN Production.ScrapReason AS sr
        ON wo.ScrapReasonID = sr.ScrapReasonID
    JOIN Production.Product AS p
        ON wo.ProductID = p.ProductID;

--Open the cursor to process one product at a time
OPEN ScrappedProducts;

DECLARE @MoneyLostPerProduct MONEY = 0,
        @TotalLoss MONEY = 0;

--Calculate money lost per product by processing one product
--at a time
DECLARE @ProductId INT,
        @UnitsScrapped SMALLINT,
        @ListPrice MONEY;

FETCH NEXT FROM ScrappedProducts
INTO @ProductId,
     @UnitsScrapped,
     @ListPrice;

WHILE @@FETCH_STATUS = 0
BEGIN
    SET @MoneyLostPerProduct = @UnitsScrapped * @ListPrice; --Calculate total loss
    SET @TotalLoss = @TotalLoss + @MoneyLostPerProduct;

    FETCH NEXT FROM ScrappedProducts
    INTO @ProductId,
         @UnitsScrapped,
         @ListPrice;
END

--Determine status
IF (@TotalLoss > 5000)
    SELECT 'We are bankrupt!' AS Status;
ELSE
    SELECT 'We are safe!' AS Status;
--Close the cursor and release all resources assigned to the cursor
CLOSE ScrappedProducts;
DEALLOCATE ScrappedProducts;
GO


EXEC dbo.TotalLoss_CursorBased;



SELECT  SUM(page_count)
FROM    sys.dm_db_index_physical_stats(DB_ID(N'AdventureWorks2017'),
            OBJECT_ID('Production.WorkOrder'),
            DEFAULT, DEFAULT, DEFAULT);



GO
CREATE OR ALTER PROC dbo.TotalLoss
AS
SELECT CASE --Determine status based on following computation
           WHEN SUM(MoneyLostPerProduct) > 5000 THEN
               'We are bankrupt!'
           ELSE
               'We are safe!'
       END AS Status
FROM
( --Calculate total money lost for all discarded products
    SELECT SUM(wo.ScrappedQty * p.ListPrice) AS MoneyLostPerProduct
    FROM Production.WorkOrder AS wo
        JOIN Production.ScrapReason AS sr
            ON wo.ScrapReasonID = sr.ScrapReasonID
        JOIN Production.Product AS p
            ON wo.ProductID = p.ProductID
    GROUP BY p.ProductID) AS DiscardedProducts;
GO


EXEC dbo.TotalLoss;


GO
--Chapter 24
DROP DATABASE InMemoryTest
GO
--create a database
CREATE DATABASE InMemoryTest
ON PRIMARY (NAME = N'InMemoryTest_Data',
            FILENAME = N'c:\Data\InMemoryTest_Data.mdf',
            SIZE = 5GB)
LOG ON (NAME = N'InMemoryTest_Log',
        FILENAME = N'c:\Log\InMemoryTest_Log.ldf');


--alter it for in-memory
ALTER DATABASE InMemoryTest
ADD FILEGROUP InMemoryTest_InMemoryData
CONTAINS MEMORY_OPTIMIZED_DATA;
ALTER DATABASE InMemoryTest
ADD FILE (NAME = 'InMemoryTest_InMemoryData',
          FILENAME = 'c:\Data\InMemoryTest_InMemoryData.ndf')
TO FILEGROUP InMemoryTest_InMemoryData;


GO

--create memory optimized table
USE InMemoryTest;
GO
CREATE TABLE dbo.Address 
	(AddressID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY NONCLUSTERED HASH
		WITH (BUCKET_COUNT = 50000),
	AddressLine1 NVARCHAR(60) NOT NULL,
	AddressLine2 NVARCHAR(60) NULL,
	City NVARCHAR(30) NOT NULL,
	StateProvinceID INT NOT NULL,
	PostalCode NVARCHAR(15) NOT NULL,
	--[SpatialLocation geography NULL,
	--rowguid uniqueidentifier ROWGUIDCOL  NOT NULL CONSTRAINT DF_Address_rowguid  DEFAULT (newid()),
	ModifiedDate DATETIME NOT NULL
		CONSTRAINT DF_Address_ModifiedDate
		DEFAULT (GETDATE()))
WITH (MEMORY_OPTIMIZED = ON, DURABILITY = SCHEMA_AND_DATA);



SELECT a.AddressID
FROM dbo.Address AS a
WHERE a.AddressID = 42;


--move data into the table created
CREATE TABLE dbo.AddressStaging (AddressLine1 NVARCHAR(60) NOT NULL,
                                 AddressLine2 NVARCHAR(60) NULL,
                                 City NVARCHAR(30) NOT NULL,
                                 StateProvinceID INT NOT NULL,
                                 PostalCode NVARCHAR(15) NOT NULL);

INSERT dbo.AddressStaging (AddressLine1,
                           AddressLine2,
                           City,
                           StateProvinceID,
                           PostalCode)
SELECT a.AddressLine1,
       a.AddressLine2,
       a.City,
       a.StateProvinceID,
       a.PostalCode
FROM AdventureWorks2017.Person.Address AS a;

INSERT dbo.Address (AddressLine1,
                    AddressLine2,
                    City,
                    StateProvinceID,
                    PostalCode)
SELECT a.AddressLine1,
       a.AddressLine2,
       a.City,
       a.StateProvinceID,
       a.PostalCode
FROM dbo.AddressStaging AS a;

DROP TABLE dbo.AddressStaging;


--create new tables
CREATE TABLE dbo.StateProvince (StateProvinceID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY NONCLUSTERED HASH
                                                                            WITH (BUCKET_COUNT = 10000),
                                StateProvinceCode NCHAR(3) COLLATE Latin1_General_100_BIN2 NOT NULL,
                                CountryRegionCode NVARCHAR(3) NOT NULL,
                                Name VARCHAR(50) NOT NULL,
                                TerritoryID INT NOT NULL,
                                ModifiedDate DATETIME NOT NULL
                                    CONSTRAINT DF_StateProvince_ModifiedDate
                                        DEFAULT (GETDATE()))
WITH (MEMORY_OPTIMIZED = ON);



CREATE TABLE dbo.CountryRegion (CountryRegionCode NVARCHAR(3) NOT NULL,
                                Name VARCHAR(50) NOT NULL,
                                ModifiedDate DATETIME NOT NULL
                                    CONSTRAINT DF_CountryRegion_ModifiedDate
                                        DEFAULT (GETDATE()),
                                CONSTRAINT PK_CountryRegion_CountryRegionCode
                                    PRIMARY KEY CLUSTERED
                                    (
                                        CountryRegionCode ASC
                                    ));


SELECT sp.StateProvinceCode,
       sp.CountryRegionCode,
       sp.Name,
       sp.TerritoryID
INTO dbo.StateProvinceStaging
FROM AdventureWorks2017.Person.StateProvince AS sp;

INSERT dbo.StateProvince (StateProvinceCode,
                          CountryRegionCode,
                          Name,
                          TerritoryID)
SELECT StateProvinceCode,
       CountryRegionCode,
       Name,
       TerritoryID
FROM dbo.StateProvinceStaging;


DROP TABLE dbo.StateProvinceStaging;


INSERT dbo.CountryRegion (CountryRegionCode,
                          Name)
SELECT cr.CountryRegionCode,
       cr.Name
FROM AdventureWorks2017.Person.CountryRegion AS cr;




--load the data
SELECT  sp.StateProvinceCode,
        sp.CountryRegionCode,
        sp.Name,
        sp.TerritoryID
INTO    dbo.StateProvinceStaging
FROM    AdventureWorks2017.Person.StateProvince AS sp;

INSERT  dbo.StateProvince
        (StateProvinceCode,
         CountryRegionCode,
         Name,
         TerritoryID
        )
SELECT  stateprovincecode,
        countryregioncode,
        name,
        territoryid
FROM    dbo.stateprovincestaging;


DROP TABLE dbo.StateProvinceStaging;


INSERT  dbo.countryregion
        (countryregioncode,
         name
        )
        SELECT  cr.CountryRegionCode,
                cr.Name
        FROM    AdventureWorks2017.Person.CountryRegion AS cr;




--retrieve data from memory-optimized tables
USE InMemoryTest;
SELECT a.AddressLine1,
       a.City,
       a.PostalCode,
       sp.Name AS StateProvinceName,
       cr.Name AS CountryName
FROM dbo.Address AS a
    JOIN dbo.StateProvince AS sp
        ON sp.StateProvinceID = a.StateProvinceID
    JOIN dbo.CountryRegion AS cr
        ON cr.CountryRegionCode = sp.CountryRegionCode
WHERE a.AddressID = 42;





USE AdventureWorks2017
SELECT a.AddressLine1,
       a.City,
       a.PostalCode,
       sp.Name AS StateProvinceName,
       cr.Name AS CountryName
FROM Person.Address AS a
    JOIN Person.StateProvince AS sp
        ON sp.StateProvinceID = a.StateProvinceID
    JOIN Person.CountryRegion AS cr
        ON cr.CountryRegionCode = sp.CountryRegionCode
WHERE a.AddressID = 42;






--hash index


SELECT i.name AS [index name],
       hs.total_bucket_count,
       hs.empty_bucket_count,
       hs.avg_chain_length,
       hs.max_chain_length
FROM sys.dm_db_xtp_hash_index_stats AS hs
    JOIN sys.indexes AS i
        ON hs.object_id = i.object_id
           AND hs.index_id = i.index_id
WHERE OBJECT_NAME(hs.object_id) = 'Address';



--nonclustered index
SELECT  a.AddressLine1,
        a.City,
        a.PostalCode,
        sp.Name AS StateProvinceName,
        cr.Name AS CountryName
FROM    dbo.Address AS a
        JOIN dbo.StateProvince AS sp
        ON sp.StateProvinceID = a.StateProvinceID
        JOIN dbo.CountryRegion AS cr
        ON cr.CountryRegionCode = sp.CountryRegionCode
WHERE   a.City = 'Walla Walla'; 
GO 50



DROP TABLE dbo.Address;
GO

CREATE TABLE dbo.Address (
	AddressID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY NONCLUSTERED HASH
		WITH (BUCKET_COUNT = 50000),
	AddressLine1 NVARCHAR(60) NOT NULL,
	AddressLine2 NVARCHAR(60) NULL,
	City NVARCHAR(30) NOT NULL,
	StateProvinceID INT NOT NULL,
	PostalCode NVARCHAR(15) NOT NULL,
	ModifiedDate DATETIME NOT NULL
	CONSTRAINT DF_Address_ModifiedDate
		DEFAULT (GETDATE()),
	INDEX nci NONCLUSTERED (City))
WITH (MEMORY_OPTIMIZED = ON);




DBCC SHOW_STATISTICS ('dbo.Address','nci')
DBCC SHOW_STATISTICS (Address,[PK__Address__091C2A1A21648C8B])



ALTER TABLE dbo.Address ADD INDEX nci (City);


ALTER TABLE dbo.Address ADD INDEX ccs CLUSTERED COLUMNSTORE;



--statistics maintenance
UPDATE STATISTICS dbo.Address WITH FULLSCAN, NORECOMPUTE;



--natively compiled procedures
CREATE PROC dbo.AddressDetails @City NVARCHAR(30)
    WITH NATIVE_COMPILATION,
         SCHEMABINDING,
         EXECUTE AS OWNER
AS
BEGIN ATOMIC WITH (TRANSACTION ISOLATION LEVEL = SNAPSHOT, LANGUAGE = N'us_english')
    SELECT a.AddressLine1,
           a.City,
           a.PostalCode,
           sp.Name AS StateProvinceName,
           cr.Name AS CountryName
    FROM dbo.Address AS a
        JOIN dbo.StateProvince AS sp
            ON sp.StateProvinceID = a.StateProvinceID
        JOIN dbo.CountryRegion AS cr
            ON cr.CountryRegionCode = sp.CountryRegionCode
    WHERE a.City = @City;
END





DROP TABLE dbo.CountryRegion

CREATE TABLE dbo.CountryRegion (CountryRegionCode NVARCHAR(3) NOT NULL,
                                Name VARCHAR(50) NOT NULL,
                                ModifiedDate DATETIME NOT NULL
                                    CONSTRAINT DF_CountryRegion_ModifiedDate
                                        DEFAULT (GETDATE()),
                                CONSTRAINT PK_CountryRegion_CountryRegionCode
                                    PRIMARY KEY NONCLUSTERED
                                    (
                                        CountryRegionCode ASC
                                    ))
WITH (MEMORY_OPTIMIZED = ON);


SELECT cr.CountryRegionCode,
       cr.Name,
       cr.ModifiedDate
INTO dbo.CountryRegionStaging
FROM AdventureWorks2017.Person.CountryRegion AS cr;

INSERT INTO dbo.CountryRegion (CountryRegionCode,
                                  Name,
                                  ModifiedDate)
SELECT crs.CountryRegionCode,
       crs.Name,
       crs.ModifiedDate
FROM dbo.CountryRegionStaging AS crs



EXEC dbo.AddressDetails 'Walla Walla'







--in-memory test
USE InMemoryTest;
GO

CREATE TABLE dbo.AddressStaging
    (
     AddressID INT NOT NULL
                   IDENTITY(1, 1)
                   PRIMARY KEY,
     AddressLine1 NVARCHAR(60) NOT NULL,
     AddressLine2 NVARCHAR(60) NULL,
     City NVARCHAR(30) NOT NULL,
     StateProvinceID INT NOT NULL,
     PostalCode NVARCHAR(15) NOT NULL
    );





--wizard
CREATE OR ALTER PROCEDURE dbo.FailWizard (@City NVARCHAR(30))
AS
SELECT a.AddressLine1,
       a.City,
       a.PostalCode,
       sp.Name AS StateProvinceName,
       cr.Name AS CountryName
FROM dbo.Address AS a
    JOIN dbo.StateProvince AS sp
        ON sp.StateProvinceID = a.StateProvinceID
    JOIN dbo.CountryRegion AS cr WITH (NOLOCK)
        ON cr.CountryRegionCode = sp.CountryRegionCode
WHERE a.City = @City;
GO

CREATE OR ALTER PROCEDURE dbo.PassWizard (@City NVARCHAR(30))
AS
SELECT a.AddressLine1,
       a.City,
       a.PostalCode,
       sp.Name AS StateProvinceName,
       cr.Name AS CountryName
FROM dbo.Address AS a
    JOIN dbo.StateProvince AS sp
        ON sp.StateProvinceID = a.StateProvinceID
    JOIN dbo.CountryRegion AS cr
        ON cr.CountryRegionCode = sp.CountryRegionCode
WHERE a.City = @City;
GO



USE AdventureWorks2017
GO



--Chapter 25

--after running makebigadventure.sql
CREATE INDEX ix_ActualCost ON dbo.bigTransactionHistory (ActualCost);
GO




--validate that automatic tuning is in place
SELECT name,
       desired_state,
       desired_state_desc,
       actual_state,
       actual_state_desc,
       reason,
       reason_desc
FROM sys.database_automatic_tuning_options;



ALTER DATABASE current SET AUTOMATIC_TUNING (FORCE_LAST_GOOD_PLAN = ON);


--a simple query for the experiment
CREATE OR ALTER PROCEDURE dbo.ProductByCost (@ActualCost MONEY)
AS
SELECT bth.ActualCost
FROM dbo.bigTransactionHistory AS bth
JOIN dbo.bigProduct AS p
ON p.ProductID = bth.ProductID
WHERE bth.ActualCost = @ActualCost;
GO

--ensuring that Query Store is on and has a clean data set
ALTER DATABASE AdventureWorks2017 SET QUERY_STORE = ON;
ALTER DATABASE AdventureWorks2017 SET QUERY_STORE CLEAR;
ALTER DATABASE AdventureWorks2017 SET AUTOMATIC_TUNING (FORCE_LAST_GOOD_PLAN = ON);
GO



ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;
GO 
--establish a history of query performance
EXEC dbo.ProductByCost @ActualCost = 8.2205;
GO 30

--remove the plan from cache
DECLARE @PlanHandle VARBINARY(64);
SELECT  @PlanHandle = deps.plan_handle
FROM    sys.dm_exec_procedure_stats AS deps
WHERE   deps.object_id = OBJECT_ID('dbo.ProductByCost');
IF @PlanHandle IS NOT NULL
    BEGIN
        DBCC FREEPROCCACHE(@PlanHandle);
    END
GO

--execute a query that will result in a different plan
EXEC dbo.ProductByCost @ActualCost = 0.0;
GO

--establish a new history of poor performance
EXEC dbo.ProductByCost @ActualCost = 8.2205;
GO 15



SELECT ddtr.type,
       ddtr.reason,
       ddtr.last_refresh,
       ddtr.state,
       ddtr.score,
       ddtr.details
FROM sys.dm_db_tuning_recommendations AS ddtr;




WITH DbTuneRec
AS (SELECT ddtr.reason,
           ddtr.score,
           pfd.query_id,
           pfd.regressedPlanId,
           pfd.recommendedPlanId,
           JSON_VALUE(ddtr.state,
                      '$.currentValue') AS CurrentState,
           JSON_VALUE(ddtr.state,
                      '$.reason') AS CurrentStateReason,
           JSON_VALUE(ddtr.details,
                      '$.implementationDetails.script') AS ImplementationScript
    FROM sys.dm_db_tuning_recommendations AS ddtr
        CROSS APPLY
        OPENJSON(ddtr.details,
                 '$.planForceDetails')
        WITH (query_id INT '$.queryId',
              regressedPlanId INT '$.regressedPlanId',
              recommendedPlanId INT '$.recommendedPlanId') AS pfd)
SELECT qsq.query_id,
       dtr.reason,
       dtr.score,
       dtr.CurrentState,
       dtr.CurrentStateReason,
       qsqt.query_sql_text,
       CAST(rp.query_plan AS XML) AS RegressedPlan,
       CAST(sp.query_plan AS XML) AS SuggestedPlan,
       dtr.ImplementationScript
FROM DbTuneRec AS dtr
    JOIN sys.query_store_plan AS rp
        ON rp.query_id = dtr.query_id
           AND rp.plan_id = dtr.regressedPlanId
    JOIN sys.query_store_plan AS sp
        ON sp.query_id = dtr.query_id
           AND sp.plan_id = dtr.recommendedPlanId
    JOIN sys.query_store_query AS qsq
        ON qsq.query_id = rp.query_id
    JOIN sys.query_store_query_text AS qsqt
        ON qsqt.query_text_id = qsq.query_text_id;



--enable automated tuning
ALTER DATABASE current SET AUTOMATIC_TUNING (FORCE_LAST_GOOD_PLAN = ON);



--disable automated tuning
ALTER DATABASE current SET AUTOMATIC_TUNING (FORCE_LAST_GOOD_PLAN = OFF);



--reset cache and rerun regressed plan
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;
GO

EXEC dbo.ProductByCost @ActualCost = 8.2205;
GO 30

--remove the plan from cache
DECLARE @PlanHandle VARBINARY(64);
SELECT  @PlanHandle = deps.plan_handle
FROM    sys.dm_exec_procedure_stats AS deps
WHERE   deps.object_id = OBJECT_ID('dbo.ProductByCost');
IF @PlanHandle IS NOT NULL
    BEGIN
        DBCC FREEPROCCACHE(@PlanHandle);
    END
GO

--execute a query that will result in a different plan
EXEC dbo.ProductByCost @ActualCost = 0.0;
GO

--establish a new history of poor performance
EXEC dbo.ProductByCost @ActualCost = 8.2205;
GO 15




USE QueryPerformanceTuning
GO
--connect to the cloud for this


CREATE OR ALTER PROCEDURE dbo.CustomerInfo
(@Firstname NVARCHAR(50))
AS
SELECT c.FirstName,
       c.LastName,
       c.Title,
       a.City
FROM SalesLT.Customer AS c
    JOIN SalesLT.CustomerAddress AS ca
        ON ca.CustomerID = c.CustomerID
    JOIN SalesLT.Address AS a
        ON a.AddressID = ca.AddressID
WHERE c.FirstName = @Firstname;
GO


CREATE INDEX TestDuplicate ON SalesLT.Customer (EmailAddress)
GO

CREATE OR ALTER PROCEDURE dbo.EmailInfo (@EmailAddress nvarchar(50))
AS
SELECT c.EmailAddress,
       c.Title,
       soh.OrderDate
FROM SalesLT.Customer AS c
    JOIN SalesLT.SalesOrderHeader AS soh
        ON soh.CustomerID = c.CustomerID
WHERE c.EmailAddress = @EmailAddress;
GO

CREATE OR ALTER PROCEDURE dbo.SalesInfo (@firstName NVARCHAR(50))
AS
SELECT c.FirstName,
       c.LastName,
       c.Title,
       soh.OrderDate
FROM SalesLT.Customer AS c
    JOIN SalesLT.SalesOrderHeader AS soh
        ON soh.CustomerID = c.CustomerID
WHERE c.FirstName = @firstName
GO


CREATE OR ALTER PROCEDURE dbo.OddName (@FirstName NVARCHAR(50))
AS
SELECT c.FirstName
FROM SalesLT.Customer AS c
WHERE c.FirstName BETWEEN 'Brian'
                  AND     @FirstName
GO


ALTER DATABASE CURRENT SET QUERY_STORE = ON;



SELECT * FROM sys.dm_db_tuning_recommendations AS ddtr



--adaptive query processing
--batch mode memory grant
CREATE EVENT SESSION MemoryGrant
ON SERVER
    ADD EVENT sqlserver.additional_memory_grant
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.memory_grant_feedback_loop_disabled
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.memory_grant_updated_by_feedback
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.query_memory_grant_usage
    (WHERE (sqlserver.database_name = N'AdventureWorks2017')),
    ADD EVENT sqlserver.sql_batch_completed
    (WHERE (sqlserver.database_name = N'AdventureWorks2017'))
WITH (TRACK_CAUSALITY = ON);
GO


--stored proc
CREATE OR ALTER PROCEDURE dbo.CostCheck (@Cost MONEY)
AS
SELECT p.Name,
       AVG(th.Quantity),
       AVG(th.ActualCost)
FROM dbo.bigTransactionHistory AS th
    JOIN dbo.bigProduct AS p
        ON p.ProductID = th.ProductID
WHERE th.ActualCost = @Cost
GROUP BY p.Name;


EXEC dbo.CostCheck @Cost = 0;





EXEC dbo.CostCheck @Cost = 15.035;


ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE; 



--Interleaved execution
CREATE OR ALTER FUNCTION dbo.SalesInfo ()
RETURNS @return_variable TABLE (SalesOrderID INT,
                                OrderDate DATETIME,
                                SalesPersonID INT,
                                PurchaseOrderNumber dbo.OrderNumber,
                                AccountNumber dbo.AccountNumber,
                                ShippingCity NVARCHAR(30))
AS
BEGIN;
    INSERT INTO @return_variable (SalesOrderID,
                                  OrderDate,
                                  SalesPersonID,
                                  PurchaseOrderNumber,
                                  AccountNumber,
                                  ShippingCity)
    SELECT soh.SalesOrderID,
           soh.OrderDate,
           soh.SalesPersonID,
           soh.PurchaseOrderNumber,
           soh.AccountNumber,
           a.City
    FROM Sales.SalesOrderHeader AS soh
        JOIN Person.Address AS a
            ON soh.ShipToAddressID = a.AddressID;
    RETURN;
END;
GO

CREATE OR ALTER FUNCTION dbo.SalesDetails ()
RETURNS @return_variable TABLE (SalesOrderID INT,
                                SalesOrderDetailID INT,
                                OrderQty SMALLINT,
                                UnitPrice MONEY)
AS
BEGIN;
    INSERT INTO @return_variable (SalesOrderID,
                                  SalesOrderDetailID,
                                  OrderQty,
                                  UnitPrice)
    SELECT sod.SalesOrderID,
           sod.SalesOrderDetailID,
           sod.OrderQty,
           sod.UnitPrice
    FROM Sales.SalesOrderDetail AS sod;
    RETURN;
END;
GO


CREATE OR ALTER FUNCTION dbo.CombinedSalesInfo ()
RETURNS @return_variable TABLE (SalesPersonID INT,
                                ShippingCity NVARCHAR(30),
                                OrderDate DATETIME,
                                PurchaseOrderNumber dbo.OrderNumber,
                                AccountNumber dbo.AccountNumber,
                                OrderQty SMALLINT,
                                UnitPrice MONEY)
AS
BEGIN;
    INSERT INTO @return_variable (SalesPersonID,
                                  ShippingCity,
                                  OrderDate,
                                  PurchaseOrderNumber,
                                  AccountNumber,
                                  OrderQty,
                                  UnitPrice)
    SELECT si.SalesPersonID,
           si.ShippingCity,
           si.OrderDate,
           si.PurchaseOrderNumber,
           si.AccountNumber,
           sd.OrderQty,
           sd.UnitPrice
    FROM dbo.SalesInfo() AS si
        JOIN dbo.SalesDetails() AS sd
            ON si.SalesOrderID = sd.SalesOrderID;
    RETURN;
END;
GO



ALTER DATABASE SCOPED CONFIGURATION SET DISABLE_INTERLEAVED_EXECUTION_TVF = ON;
GO
--1
SELECT csi.OrderDate,
       csi.PurchaseOrderNumber,
       csi.AccountNumber,
       csi.OrderQty,
       csi.UnitPrice,
       sp.SalesQuota
FROM dbo.CombinedSalesInfo() AS csi
    JOIN Sales.SalesPerson AS sp
        ON csi.SalesPersonID = sp.BusinessEntityID
WHERE csi.SalesPersonID = 277
      AND csi.ShippingCity = 'Odessa';
GO 20

ALTER DATABASE SCOPED CONFIGURATION SET DISABLE_INTERLEAVED_EXECUTION_TVF = OFF;
GO
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;
GO
--2
SELECT csi.OrderDate,
       csi.PurchaseOrderNumber,
       csi.AccountNumber,
       csi.OrderQty,
       csi.UnitPrice,
       sp.SalesQuota
FROM dbo.CombinedSalesInfo() AS csi
    JOIN Sales.SalesPerson AS sp
        ON csi.SalesPersonID = sp.BusinessEntityID
WHERE csi.SalesPersonID = 277
      AND csi.ShippingCity = 'Odessa';
GO 20




CREATE OR ALTER FUNCTION dbo.AllSalesInfo (@SalesPersonID INT,
                                           @ShippingCity VARCHAR(50))
RETURNS @return_variable TABLE (SalesPersonID INT,
                                ShippingCity NVARCHAR(30),
                                OrderDate DATETIME,
                                PurchaseOrderNumber dbo.OrderNumber,
                                AccountNumber dbo.AccountNumber,
                                OrderQty SMALLINT,
                                UnitPrice MONEY)
AS
BEGIN;

    INSERT INTO @return_variable (SalesPersonID,
                                  ShippingCity,
                                  OrderDate,
                                  PurchaseOrderNumber,
                                  AccountNumber,
                                  OrderQty,
                                  UnitPrice)
    SELECT soh.SalesPersonID,
           a.City,
           soh.OrderDate,
           soh.PurchaseOrderNumber,
           soh.AccountNumber,
           sod.OrderQty,
           sod.UnitPrice
    FROM Sales.SalesOrderHeader AS soh
        JOIN Person.Address AS a
            ON a.AddressID = soh.ShipToAddressID
        JOIN Sales.SalesOrderDetail AS sod
            ON sod.SalesOrderID = soh.SalesOrderID
    WHERE soh.SalesPersonID = @SalesPersonID
          AND a.City = @ShippingCity;
    RETURN;
END;
GO




SELECT asi.OrderDate,
       asi.PurchaseOrderNumber,
       asi.AccountNumber,
       asi.OrderQty,
       asi.UnitPrice,
       sp.SalesQuota
FROM dbo.AllSalesInfo(277,'Odessa') AS asi
    JOIN Sales.SalesPerson AS sp
        ON asi.SalesPersonID = sp.BusinessEntityID;
GO 20




--get the plans out of the query store
SELECT CAST(qsp.query_plan AS XML)
FROM sys.query_store_query AS qsq
    JOIN sys.query_store_plan AS qsp
        ON qsp.query_id = qsq.query_id
WHERE qsq.object_id = OBJECT_ID('dbo.AllSalesInfo');
GO




--Chapter 26
--no code


--Chapter 27

--sample load procedures
USE AdventureWorks2017;
GO

CREATE OR ALTER PROCEDURE dbo.ShoppingCart @ShoppingCartId VARCHAR(50)
AS
--provides the output from the shopping cart including the line total
SELECT sci.Quantity,
       p.ListPrice,
       p.ListPrice * sci.Quantity AS LineTotal,
       p.Name
FROM Sales.ShoppingCartItem AS sci
    JOIN Production.Product AS p
        ON sci.ProductID = p.ProductID
WHERE sci.ShoppingCartID = @ShoppingCartId;
GO

CREATE OR ALTER PROCEDURE dbo.ProductBySalesOrder @SalesOrderID INT
AS
/*provides a list of products from a particular sales order, 
and provides line ordering by modified date but ordered 
by product name*/

SELECT ROW_NUMBER() OVER (ORDER BY sod.ModifiedDate) AS LineNumber,
       p.Name,
       sod.LineTotal
FROM Sales.SalesOrderHeader AS soh
    JOIN Sales.SalesOrderDetail AS sod
        ON soh.SalesOrderID = sod.SalesOrderID
    JOIN Production.Product AS p
        ON sod.ProductID = p.ProductID
WHERE soh.SalesOrderID = @SalesOrderID
ORDER BY p.Name ASC;
GO

CREATE OR ALTER PROCEDURE dbo.PersonByFirstName @FirstName NVARCHAR(50)
AS
--gets anyone by first name from the Person table
SELECT p.BusinessEntityID,
       p.Title,
       p.LastName,
       p.FirstName,
       p.PersonType
FROM Person.Person AS p
WHERE p.FirstName = @FirstName;
GO


CREATE OR ALTER PROCEDURE dbo.ProductTransactionsSinceDate
    @LatestDate DATETIME,
    @ProductName NVARCHAR(50)
AS
--Gets the latest transaction against 
--all products that have a transaction
SELECT p.Name,
       th.ReferenceOrderID,
       th.ReferenceOrderLineID,
       th.TransactionType,
       th.Quantity
FROM Production.Product AS p
    JOIN Production.TransactionHistory AS th
        ON p.ProductID = th.ProductID
           AND th.TransactionID = (   SELECT TOP (1)
                                             th2.TransactionID
                                      FROM Production.TransactionHistory AS th2
                                      WHERE th2.ProductID = p.ProductID
                                      ORDER BY th2.TransactionID DESC)
WHERE th.TransactionDate > @LatestDate
      AND p.Name LIKE @ProductName;
GO


CREATE OR ALTER PROCEDURE dbo.PurchaseOrderBySalesPersonName
    @LastName NVARCHAR(50),
    @VendorID INT = NULL
AS
SELECT poh.PurchaseOrderID,
       poh.OrderDate,
       pod.LineTotal,
       p.Name AS ProductName,
       e.JobTitle,
       per.LastName + ', ' + per.FirstName AS SalesPerson,
       poh.VendorID
FROM Purchasing.PurchaseOrderHeader AS poh
    JOIN Purchasing.PurchaseOrderDetail AS pod
        ON poh.PurchaseOrderID = pod.PurchaseOrderID
    JOIN Production.Product AS p
        ON pod.ProductID = p.ProductID
    JOIN HumanResources.Employee AS e
        ON poh.EmployeeID = e.BusinessEntityID
    JOIN Person.Person AS per
        ON e.BusinessEntityID = per.BusinessEntityID
WHERE per.LastName LIKE @LastName
      AND poh.VendorID = COALESCE(@VendorID,
                                  poh.VendorID)
ORDER BY per.LastName,
         per.FirstName;
GO

CREATE OR ALTER PROCEDURE dbo.TotalSalesByProduct @ProductID INT
AS
--retrieve aggregation of sales based on a productid
SELECT SUM((isnull((sod.UnitPrice*((1.0)-sod.UnitPriceDiscount))*sod.OrderQty,(0.0)))) AS TotalSales,
       AVG(sod.OrderQty) AS AverageQty,
       AVG(sod.UnitPrice) AS AverageUnitPrice,
	   SUM(sod.LineTotal)
FROM Sales.SalesOrderDetail AS sod
WHERE sod.ProductID = @ProductID
GROUP BY sod.ProductID;
GO



--generate the load
EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%';
GO
EXEC dbo.ShoppingCart @ShoppingCartId = '20621';
GO
EXEC dbo.ProductBySalesOrder @SalesOrderID = 43867;
GO
EXEC dbo.PersonByFirstName @FirstName = 'Gretchen';
GO
EXEC dbo.ProductTransactionsSinceDate @LatestDate = '9/1/2004',
                                      @ProductName = 'Hex Nut%';
GO
EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%',
                                        @VendorID = 1496;
GO
EXEC dbo.TotalSalesByProduct @ProductID = 707;
GO





DROP TABLE IF EXISTS dbo.ExEvents;
GO
WITH xEvents
AS (SELECT object_name AS xEventName,
           CAST(event_data AS XML) AS xEventData
    FROM sys.fn_xe_file_target_read_file('C:\PerfData\QueryPerfTuning2017*.xel',
                                         NULL,
                                         NULL,
                                         NULL) )
SELECT xEventName,
       xEventData.value('(/event/data[@name=''duration'']/value)[1]',
                        'bigint') AS Duration,
       xEventData.value('(/event/data[@name=''physical_reads'']/value)[1]',
                        'bigint') AS PhysicalReads,
       xEventData.value('(/event/data[@name=''logical_reads'']/value)[1]',
                        'bigint') AS LogicalReads,
       xEventData.value('(/event/data[@name=''cpu_time'']/value)[1]',
                        'bigint') AS CpuTime,
       CASE xEventName
           WHEN 'sql_batch_completed' THEN
               xEventData.value('(/event/data[@name=''batch_text'']/value)[1]',
                                'varchar(max)')
           WHEN 'rpc_completed' THEN
               xEventData.value('(/event/data[@name=''statement'']/value)[1]',
                                'varchar(max)')
       END AS SQLText,
       xEventData.value('(/event/data[@name=''query_plan_hash'']/value)[1]',
                        'binary(8)') AS QueryPlanHash
INTO dbo.ExEvents
FROM xEvents;



SELECT ee.SQLText,
       SUM(Duration) AS SumDuration,
       AVG(Duration) AS AvgDuration,
       COUNT(Duration) AS CountDuration
FROM dbo.ExEvents AS ee
GROUP BY ee.SQLText;


--not to be run in production
ALTER DATABASE SCOPED CONFIGURATION CLEAR PROCEDURE_CACHE;
DBCC DROPCLEANBUFFERS;
GO
SET STATISTICS TIME ON;
GO
SET STATISTICS IO ON;
GO
EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%';
GO
SET STATISTICS TIME OFF;
GO
SET STATISTICS IO OFF;
GO


--statistics
DBCC SHOW_STATISTICS('HumanResources.Employee', 'PK_Employee_BusinessEntityID');



--fragmentation
SELECT s.avg_fragmentation_in_percent,
       s.fragment_count,
       s.page_count,
       s.avg_page_space_used_in_percent,
       s.record_count,
       s.avg_record_size_in_bytes,
       s.index_id
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'HumanResources.Employee'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS s
WHERE s.record_count > 0
ORDER BY s.index_id;

SELECT s.avg_fragmentation_in_percent,
       s.fragment_count,
       s.page_count,
       s.avg_page_space_used_in_percent,
       s.record_count,
       s.avg_record_size_in_bytes,
       s.index_id
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'Purchasing.PurchaseOrderHeader'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS s
WHERE s.record_count > 0
ORDER BY s.index_id;

SELECT s.avg_fragmentation_in_percent,
       s.fragment_count,
       s.page_count,
       s.avg_page_space_used_in_percent,
       s.record_count,
       s.avg_record_size_in_bytes,
       s.index_id
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'Purchasing.PurchaseOrderDetail'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS s
WHERE s.record_count > 0
ORDER BY s.index_id;

SELECT s.avg_fragmentation_in_percent,
       s.fragment_count,
       s.page_count,
       s.avg_page_space_used_in_percent,
       s.record_count,
       s.avg_record_size_in_bytes,
       s.index_id
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'Production.Product'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS s
WHERE s.record_count > 0
ORDER BY s.index_id;

SELECT s.avg_fragmentation_in_percent,
       s.fragment_count,
       s.page_count,
       s.avg_page_space_used_in_percent,
       s.record_count,
       s.avg_record_size_in_bytes,
       s.index_id
FROM sys.dm_db_index_physical_stats(DB_ID('AdventureWorks2017'),
                                    OBJECT_ID(N'Person.Person'),
                                    NULL,
                                    NULL,
                                    'Sampled') AS s
WHERE s.record_count > 0
ORDER BY s.index_id;




--execution plan
EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%';
GO


CREATE OR ALTER PROCEDURE dbo.PurchaseOrderBySalesPersonName
    @LastName NVARCHAR(50),
    @VendorID INT = NULL
AS
IF @VendorID IS NULL
BEGIN
    SELECT poh.PurchaseOrderID,
           poh.OrderDate,
           pod.LineTotal,
           p.Name AS ProductName,
           e.JobTitle,
           per.LastName + ', ' + per.FirstName AS SalesPerson,
           poh.VendorID
    FROM Purchasing.PurchaseOrderHeader AS poh
        JOIN Purchasing.PurchaseOrderDetail AS pod
            ON poh.PurchaseOrderID = pod.PurchaseOrderID
        JOIN Production.Product AS p
            ON pod.ProductID = p.ProductID
        JOIN HumanResources.Employee AS e
            ON poh.EmployeeID = e.BusinessEntityID
        JOIN Person.Person AS per
            ON e.BusinessEntityID = per.BusinessEntityID
    WHERE per.LastName LIKE @LastName
    ORDER BY per.LastName,
             per.FirstName;
END
ELSE
BEGIN
    SELECT poh.PurchaseOrderID,
           poh.OrderDate,
           pod.LineTotal,
           p.Name AS ProductName,
           e.JobTitle,
           per.LastName + ', ' + per.FirstName AS SalesPerson,
           poh.VendorID
    FROM Purchasing.PurchaseOrderHeader AS poh
        JOIN Purchasing.PurchaseOrderDetail AS pod
            ON poh.PurchaseOrderID = pod.PurchaseOrderID
        JOIN Production.Product AS p
            ON pod.ProductID = p.ProductID
        JOIN HumanResources.Employee AS e
            ON poh.EmployeeID = e.BusinessEntityID
        JOIN Person.Person AS per
            ON e.BusinessEntityID = per.BusinessEntityID
    WHERE per.LastName LIKE @LastName
          AND poh.VendorID = @VendorID
    ORDER BY per.LastName,
             per.FirstName;
END
GO


CREATE NONCLUSTERED INDEX IX_PurchaseOrderHeader_EmployeeID
ON Purchasing.PurchaseOrderHeader
(
    EmployeeID ASC
)
INCLUDE
(
    VendorID,
    OrderDate
)
WITH DROP_EXISTING;

EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%';
GO 50


EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%',
                                        @VendorID = 1496;
GO 50



CREATE NONCLUSTERED INDEX IX_PurchaseOrderHeader_VendorID
ON Purchasing.PurchaseOrderHeader
(
    VendorID ASC
)
INCLUDE
(
    OrderDate,
    EmployeeID,
    PurchaseOrderID
)
WITH DROP_EXISTING;
GO





CREATE OR ALTER PROCEDURE dbo.PurchaseOrderByLastName @LastName NVARCHAR(50)
AS
SELECT poh.PurchaseOrderID,
       poh.OrderDate,
       pod.LineTotal,
       p.Name AS ProductName,
       e.JobTitle,
       per.LastName + ', ' + per.FirstName AS SalesPerson,
       poh.VendorID
FROM Purchasing.PurchaseOrderHeader AS poh
    JOIN Purchasing.PurchaseOrderDetail AS pod
        ON poh.PurchaseOrderID = pod.PurchaseOrderID
    JOIN Production.Product AS p
        ON pod.ProductID = p.ProductID
    JOIN HumanResources.Employee AS e
        ON poh.EmployeeID = e.BusinessEntityID
    JOIN Person.Person AS per
        ON e.BusinessEntityID = per.BusinessEntityID
WHERE per.LastName LIKE @LastName
ORDER BY per.LastName,
         per.FirstName;
GO

CREATE OR ALTER PROCEDURE dbo.PurchaseOrderByLastNameVendor
    @LastName NVARCHAR(50),
    @VendorID INT
AS
SELECT poh.PurchaseOrderID,
       poh.OrderDate,
       pod.LineTotal,
       p.Name AS ProductName,
       e.JobTitle,
       per.LastName + ', ' + per.FirstName AS SalesPerson,
       poh.VendorID
FROM Purchasing.PurchaseOrderHeader AS poh
    JOIN Purchasing.PurchaseOrderDetail AS pod
        ON poh.PurchaseOrderID = pod.PurchaseOrderID
    JOIN Production.Product AS p
        ON pod.ProductID = p.ProductID
    JOIN HumanResources.Employee AS e
        ON poh.EmployeeID = e.BusinessEntityID
    JOIN Person.Person AS per
        ON e.BusinessEntityID = per.BusinessEntityID
WHERE per.LastName LIKE @LastName
      AND poh.VendorID = @VendorID
ORDER BY per.LastName,
         per.FirstName;
GO



CREATE OR ALTER PROCEDURE dbo.PurchaseOrderBySalesPersonName
    @LastName NVARCHAR(50),
    @VendorID INT = NULL
AS
IF @VendorID IS NULL
BEGIN
    EXEC dbo.PurchaseOrderByLastName @LastName;
END
ELSE
BEGIN
    EXEC dbo.PurchaseOrderByLastNameVendor @LastName, @VendorID;
END
GO


EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%';
GO
EXEC dbo.ShoppingCart @ShoppingCartId = '20621';
GO
EXEC dbo.ProductBySalesOrder @SalesOrderID = 43867;
GO
EXEC dbo.PersonByFirstName @FirstName = 'Gretchen';
GO
EXEC dbo.ProductTransactionsSinceDate @LatestDate = '9/1/2004',
                                      @ProductName = 'Hex Nut%';
GO
EXEC dbo.PurchaseOrderBySalesPersonName @LastName = 'Hill%',
                                        @VendorID = 1496;
GO
EXEC dbo.TotalSalesByProduct @ProductID = 707;
GO
EXEC dbo.TotalSalesByProduct @ProductID = 707;
GO



--alternatives
INSERT  INTO Purchasing.PurchaseOrderDetail
        (PurchaseOrderID,
         DueDate,
         OrderQty,
         ProductID,
         UnitPrice,
         ReceivedQty,
         RejectedQty,
         ModifiedDate
        )
VALUES  (1066,
         '1/1/2009',
         1,
         42,
         98.6,
         5,
         4,
         '1/1/2009'
        ) ;
GO

SELECT  p.[Name],
        psc.[Name]
FROM    Production.Product AS p,
        Production.ProductSubCategory AS psc ; 
GO

SELECT p.Name,
       c.Name
FROM Production.Product AS p,
     Production.ProductSubcategory AS c;
GO

SELECT p.Name,
       c.Name
FROM Production.Product AS p
    JOIN Production.ProductSubcategory AS c
        ON p.ProductSubcategoryID = c.ProductSubcategoryID;


--Chapter 28
CREATE NONCLUSTERED INDEX AK_Product_Name
ON Production.Product
(
    Name ASC
)
WITH (DROP_EXISTING = ON)
ON [PRIMARY];
GO


SELECT DISTINCT
       (p.Name)
FROM Production.Product AS p;


CREATE UNIQUE NONCLUSTERED INDEX AK_Product_Name
ON Production.Product
(
    Name ASC
)
WITH (DROP_EXISTING = ON)
ON [PRIMARY];
GO


--Create two test tables
DROP TABLE IF EXISTS dbo.Test1;
GO
CREATE TABLE dbo.Test1 (C1 INT,
                        C2 INT CHECK (C2 BETWEEN 10
                                         AND     20));
INSERT INTO dbo.Test1
VALUES (11, 12);
GO
DROP TABLE IF EXISTS dbo.Test2;
GO
CREATE TABLE dbo.Test2 (C1 INT,
                        C2 INT);
INSERT INTO dbo.Test2
VALUES (101, 102);


SELECT T1.C1,
       T1.C2,
       T2.C2
FROM dbo.Test1 AS T1
    JOIN dbo.Test2 AS T2
        ON T1.C1 = T2.C2
           AND T1.C2 = 20;
GO
SELECT T1.C1,
       T1.C2,
       T2.C2
FROM dbo.Test1 AS T1
    JOIN dbo.Test2 AS T2
        ON T1.C1 = T2.C2
           AND T1.C2 = 30;



SELECT p.*
FROM Production.Product AS p
WHERE p.Name LIKE '%Caps';



SELECT soh.SalesOrderNumber
FROM Sales.SalesOrderHeader AS soh
WHERE 'SO5' = LEFT(SalesOrderNumber, 3);

SELECT soh.SalesOrderNumber
FROM Sales.SalesOrderHeader AS soh
WHERE SalesOrderNumber LIKE 'SO5%';
















